	--==Commands Script for MonitorsPlus==--

if HAVE_DEBUG

COM_AddCommand("mpdebug", function(p)
	if p == lp
		MPDEBUG = not MPDEBUG
	end
end)

end

local function nodewrapper(n)
	return max(0, min(n, 31))
end

COM_AddCommand("mp_globaleffect", function(p, effect)
	effect = tostring(effect)
	if not _G["gef_"..effect]
		CONS_Printf(p, "Invalid effect.")
		return
	end
	MP_addGlobalEffect(_G["gef_"..effect])
end, COM_ADMIN)

COM_AddCommand("mp_geteffect", function(p, node, effect)

	if tonumber(node) == nil
	or not players[tonumber(node)]
		CONS_Printf(p, "Invalid node.")
		return
	end

    effect = tostring(effect)
	if not _G["ef_"..effect]
		CONS_Printf(p, "Invalid effect.")
		return
	end
    MP_giveEffect(players[nodewrapper(tonumber(node))], _G["ef_"..effect])
end, COM_ADMIN)

/*if HAVE_DEBUG

COM_AddCommand("rollkarma", function(p, node)
	if tonumber(node) == nil
	or not players[tonumber(node)]
		CONS_Printf(p, "Invalid node.")
		return
	end
	MP_rollKarma(players[tonumber(node)], true)
end, COM_ADMIN)

end*/

-- name: the name of the monitor (duh)
-- mobj: what mobj to spawn
-- group: what group the monitor belongs to, will be displayed alongside other grouped monitors
-- version: what version it came from (unused in the code, but a neat extra for code divers rn I guess)
local spawnList = {
	-- Vanilla monitors
	{name = "Super Ring", mobj = MT_RING_BOX, group = "Vanilla"},
	{name = "Pity Shield", mobj = MT_PITY_BOX, group = "Vanilla"},
	{name = "Attraction Shield", mobj = MT_ATTRACT_BOX, group = "Vanilla"},
	{name = "Force Shield", mobj = MT_FORCE_BOX, group = "Vanilla"},
	{name = "Armageddon Shield", mobj = MT_ARMAGEDDON_BOX, group = "Vanilla"},
	{name = "Whirlwind Shield", mobj = MT_WHIRLWIND_BOX, group = "Vanilla"},
	{name = "Elemental Shield", mobj = MT_ELEMENTAL_BOX, group = "Vanilla"},
	{name = "Super Sneakers", mobj = MT_SNEAKERS_BOX, group = "Vanilla"},
	{name = "Extra Life", mobj = MT_1UP_BOX, group = "Vanilla"},
	{name = "Invincibility", mobj = MT_INVULN_BOX, group = "Vanilla"},
	{name = "Eggman", mobj = MT_EGGMAN_BOX, group = "Vanilla"},
	{name = "Teleporter", mobj = MT_MIXUP_BOX, group = "Vanilla"},
	{name = "Random", mobj = MT_MYSTERY_BOX, group = "Vanilla"},
	{name = "Gravity Boots", mobj = MT_GRAVITY_BOX, group = "Vanilla"},
	{name = "Recycler", mobj = MT_RECYCLER_BOX, group = "Vanilla"},
	{name = "Score (1,000 Points)", mobj = MT_SCORE1K_BOX, group = "Vanilla"},
	{name = "Score (10,000 Points)", mobj = MT_SCORE10K_BOX, group = "Vanilla"},
	{name = "Flame Shield", mobj = MT_FLAMEAURA_BOX, group = "Vanilla"},
	{name = "Bubble Shield", mobj = MT_BUBBLEWRAP_BOX, group = "Vanilla"},
	{name = "Lightning Shield", mobj = MT_THUNDERCOIN_BOX, group = "Vanilla"},
	
	-- v1.x monitors
	{name = "Hyper", mobj = MT_HYPERMONITOR, group = "v1.x", version = "v1.0"},
	{name = "Cactus Shield", mobj = MT_CACTISHIELDMONITOR, group = "v1.x", version = "v1.0"},
	{name = "End Of The World", mobj = MT_ENDMONITOR, group = "v1.x", version = "v1.0"},
	{name = "Random Hit", mobj = MT_RANDOMMONITOR, group = "v1.x", version = "v1.0"},
	{name = "Silver Ring", mobj = MT_SILVERRINGBOXMONITOR, group = "v1.x", version = "v1.0"},
	{name = "Earthquake", mobj = MT_EARTHMONITOR, group = "v1.x", version = "v1.0"},
	{name = "Drop", mobj = MT_LOSEMONITOR, group = "v1.x", version = "v1.0"},
	{name = "Supply", mobj = MT_SUPPLYMONITOR, group = "v1.x", version = "v1.0"},
	{name = "Invisibility", mobj = MT_INVISMONITOR, group = "v1.x", version = "v1.0"},
	{name = "Poison Shield", mobj = MT_POISONMONITOR, group = "v1.x", version = "v1.0"},
	{name = "ESP Shield", mobj = MT_ESPMONITOR, group = "v1.x", version = "v1.0"},
	{name = "Jumpheight", mobj = MT_JUMPMONITOR, group = "v1.x", version = "v1.0"},
	{name = "Ice Shield", mobj = MT_ICEMONITOR, group = "v1.x", version = "v1.0"},
	{name = "Super", mobj = MT_SUPERMONITOR, group = "v1.x", version = "v1.0.4"},
	{name = "Combine Ring", mobj = MT_COMBINERINGMONITOR, group = "v1.x", version = "v1.0.5"},
	{name = "Hyper Ring", mobj = MT_HYPERRINGMONITOR, group = "v1.x", version = "v1.1"},
	{name = "Reset Score", mobj = MT_RESETMONITOR, group = "v1.x", version = "v1.3"},
	{name = "Firerate", mobj = MT_FIREMONITOR, group = "v1.x", version = "v1.4"},
	{name = "Bean", mobj = MT_BEANMONITOR, group = "v1.x", version = "v1.5"},
	{name = "Platinum Ring", mobj = MT_PLATINUMMONITOR, group = "v1.x", version = "v1.5"},
	
	-- v2.x monitors
	{name = "Thunder Shield", mobj = MT_THUNDERMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Bumper Shield", mobj = MT_BUMPERMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Pizza", mobj = MT_PIZZAMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Over Booster", mobj = MT_EXPLOSIONMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Titanium Shield", mobj = MT_TITANIUMMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Web Shield", mobj = MT_WEEBMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Earth Shield", mobj = MT_DIGMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Crumble", mobj = MT_FOFMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Pancake", mobj = MT_PANCAKEMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Expand", mobj = MT_EXPANDMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Sentry", mobj = MT_SENTRYMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Goop", mobj = MT_GOOPMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Eclipse", mobj = MT_ECLIPSEMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Turbo", mobj = MT_TURBOMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Megidolaon", mobj = MT_MEGIDOLAONMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Heavy Gravity", mobj = MT_HEAVYGRAVMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Low Gravity", mobj = MT_LOWGRAVMONITOR, group = "v2.x", version = "v2.0"},
	{name = "BATKAN!!!", mobj = MT_BATKANMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Fitness", mobj = MT_FITNESSMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Blooper", mobj = MT_BLOOPERMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Regeneration", mobj = MT_REGENMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Blue Shell", mobj = MT_BSHELLMONITOR, group = "v2.x", version = "v2.0"},
	{name = "Hyper Sneakers", mobj = MT_HYPERSHOESMONITOR, group = "v2.x", version = "v2.4"},
	{name = "Juggernaut Drive", mobj = MT_JDRIVEMONITOR, group = "v2.x", version = "v2.5"},
	
	-- v3.x monitors
	{name = "Rocket Chair", mobj = MT_INSTAMONITOR, group = "v3.x", version = "v3.0"},
	{name = "Kinetic Shield", mobj = MT_ANTIMATTERMONITOR, group = "v3.x", version = "v3.0"},
	{name = "Shrink", mobj = MT_SHRINKMONITOR, group = "v3.x", version = "v3.0"},
	{name = "Grow", mobj = MT_MUSHMONITOR, group = "v3.x", version = "v3.0"},
}
-- special monitor
spawnList[-1] = {name = "Bean Screen", mobj = MT_PLEBMONITOR}	-- no group, it wont show up in the monitor list

-- command to spawn monitors
COM_AddCommand("mp_spawnmonitor", function(p, target, index)
	if not (target) then CONS_Printf(p, "mp_spawnmonitor <node> <monitor>") return end	-- didnt even get past the first argument, a shame
	
	-- find the player we put in
	local tp	-- what player we'll be spawning it on
	if (tonumber(target) != nil)	-- it's a node
		target = tonumber($)	-- make it easier on ourself from here on
		
		if (target != -1)	-- we'd be targetting everyone in this case!
			target = nodewrapper(target)
			-- try to find the player node
			if not (players[target]) then CONS_Printf(p, "".."\x82".."WARNING:".."\x80".." Player #"..target.." doesn't exist!") return end	-- doesnt exist
			tp = players[target]	-- found 'em
		end
	else	-- it's a player name, search for them!
		target = $:lower()	-- convenience
		
		for player in players.iterate
			local name = player.name:lower()
			if (name != target) then continue end
			
			-- found 'em
			tp = player
			break
		end
		
		-- check if we actually found a player
		if not (tp and tp.valid)
			CONS_Printf(p, "".."\x82".."WARNING:".."\x80".." "..target.." doesn't exist!")
			return
		end
	end
	-- validate the found player
	if (tp and tp.valid)
		if (tp.spectator) then CONS_Printf(p, "".."\x82".."WARNING:".."\x80".." "..tp.name.." is a spectator!") return end	-- spectating
		if not (tp.mo.health) then CONS_Printf(p, "".."\x82".."WARNING:".."\x80".." "..tp.name.." is dead!") return end	-- dead
	end
	
	-- find the monitor we want to spawn in
	if (index == nil) then CONS_Printf(p, "".."\x82".."WARNING:".."\x80".." You didn't enter a player index!") return end
	local function monitorError(string)
		CONS_Printf(p, string)
		CONS_Printf(p, "Use \"mp_monitorlist\" to see what monitors you can spawn!")
	end
	
	local monitorInfo
	if (tonumber(index) != nil)	-- got a direct hit?
		index = tonumber($)
		
		if not (spawnList[index]) then monitorError("".."\x82".."WARNING:".."\x80".." Monitor #"..index.." doesn't exist!") return end	-- nvm
		monitorInfo = spawnList[index]
	else	-- try find it based on name
		index = $:lower()
		
		-- go through monitors and try to find it
		local autoList = {}
		for k, v in pairs(spawnList)
			if (k == -1) then continue end	-- nooooo
			local name = v.name:lower()
			
			-- found it?
			if (name == index)
				monitorInfo = v
				break
			end
			
			-- no? save it for autocompleting afterwards if we havent found it
			local autoName = name:sub(1, index:len())
			if (autoName:find(index))
				table.insert(autoList, v)
			end
		end
		
		if not (monitorInfo)
			if (#autoList)	-- get the shortest we have
				table.sort(autoList, function(a, b)
					return a.name:len() < b.name:len()
				end)
				monitorInfo = autoList[1]
			else
				monitorError("".."\x82".."WARNING:".."\x80".." "..index.." Monitor doesn't exist!")
				return
			end
		end
	end
	
	-- now let's spawn the monitor!
	local function spawnMonitor(player)
		local mo = player.mo
		
		-- spawn the monitor away from the player
		local distance = 96
		local angle = mo.angle
		
		local monitor = P_SpawnMobjFromMobj(mo, 0, 0, 0, monitorInfo.mobj)
		monitor.scale = FRACUNIT	-- all objects would usually be FRACUNIT, anyways
		monitor.forcespawn = true
		monitor.flags = $|(MF_NOCLIPTHING)	-- we do a little bit of trolling
		while (not P_TryMove(monitor, mo.x + (distance * cos(angle)), mo.y + (distance * sin(angle)), true))
			if not (distance) then break end	-- fuck it
			distance = $-1
		end
		monitor.flags = $ & ~(MF_NOCLIPTHING)
	end
	
	if not (tp and tp.valid)	-- assume it's everyone
		for player in players.iterate
			local mo = player.mo
			if not ((mo and mo.valid) and mo.health) then continue end
			if (player.spectator) then continue end
			
			spawnMonitor(player)
		end
		CONS_Printf(p, "Spawned a "..monitorInfo.name.." Monitor on everyone!")
	else
		spawnMonitor(tp)
		CONS_Printf(p, "Spawned a "..monitorInfo.name.." Monitor on "..tp.name.."!")
	end
end, COM_ADMIN)

-- precompute tables
local groups = {}
local groupNames = ""	-- trust me, this'll help
for k, v in pairs(spawnList)
	if (k == -1) then continue end	-- nooooo
	
	local foundGroup
	for i, group in pairs(groups)
		if (group.name != v.group) then continue end
		
		-- if we're here, we found a group
		table.insert(group.monitors, {index = k, monitorInfo = v})
		foundGroup = true
		//print("added to group: "..group.name)
		break
	end
	if (foundGroup) then continue end
	
	-- if we're here, we need to create a new group!
	table.insert(groups, {name = v.group, monitors = {{index = k, monitorInfo = v}}})
	groupNames = $ + ((#groups != 1) and ", " or "")..v.group
	//print("created new group: "..v.group)
end
/*for i, group in pairs(groups)
	print(group.name)
	for monitor, info in pairs(group.monitors)
		print(info.index.." - "..info.monitorInfo.name)
	end
end*/

COM_AddCommand("mp_monitorlist", function(p, groupName)
	if not (groupName)
		CONS_Printf(p, "mp_monitorlist <group>")
		CONS_Printf(p, "Available monitor groups: "..groupNames)
		return
	end
	groupName = $:lower()
	
	-- find the group we want to display
	local group
	for k, v in pairs(groups)
		local name = v.name:lower()
		if (name != groupName) then continue end
		
		-- we found the group if we're here
		group = v
		break
	end
	if not (group)
		CONS_Printf(p, "".."\x82".."WARNING:".."\x80".." Monitor group \""..groupName.."\" does not exist!")
		CONS_Printf(p, "Available monitor groups: "..groupNames)
		return
	end
	
	CONS_Printf(p, group.name.." Monitors:")
	for monitor, info in pairs(group.monitors)
		local monitorInfo = info.monitorInfo
		CONS_Printf(p, info.index..": "..monitorInfo.name.." Monitor")
	end
end)