rawset(_G, "MP_givePlayerWeapon", function(p, weapon, ammo)
	if not G_RingSlingerGametype() return end
	if not wpn_maxammo[weapon] return end
	if not p.mo return end
	local mo = p.mo
	mo.MP_weapons = $|weapon
	mo.MP_weaponsnum[weapon] = min(wpn_maxammo[weapon], $+(ammo or wpn_pickupammo[weapon]))
end)

-- if frantic, remove in level weaponrings
/*addHook("MapLoad", do
	if not MP_franticWeapons() return end
	for m in thinkers.iterate("mobj") do
		if m and m.valid and ((m.type >= MT_BOUNCERING and m.type <= MT_GRENADERING) or (m.type >= MT_BOUNCEPICKUP and m.type <= MT_GRENADEPICKUP))
			m.flags = MF_NOGRAVITY
			m.state = S_INVISIBLE
		end
	end
end)*/

function A_AutoRing(actor)
	local p = actor.target.player
	if not p return end
	local a = P_SpawnMobj(actor.target.x, actor.target.y, actor.target.z, MT_AUTOPICKUP)
end

function A_BounceRing(actor)
	local p = actor.target.player
	if not p return end
	local a = P_SpawnMobj(actor.target.x, actor.target.y, actor.target.z, MT_BOUNCEPICKUP)
	a.radius = $*2
	a.height = $*2
	P_TeleportMove(a, a.x, a.y, a.z)
end

function A_BombRing(actor)
	local p = actor.target.player
	if not p return end
	local a = P_SpawnMobj(actor.target.x, actor.target.y, actor.target.z, MT_EXPLODEPICKUP)
	a.radius = $*2
	a.height = $*2
	P_TeleportMove(a, a.x, a.y, a.z)
end

function A_GrenadeRing(actor)
	local p = actor.target.player
	if not p return end
	local a = P_SpawnMobj(actor.target.x, actor.target.y, actor.target.z, MT_GRENADEPICKUP)
	a.radius = $*2
	a.height = $*2
	P_TeleportMove(a, a.x, a.y, a.z)
end

function A_InfinityRing(actor)
	local p = actor.target.player
	if not p return end
	local a = P_SpawnMobj(actor.target.x, actor.target.y, actor.target.z, MT_INFINITYRING)
	a.radius = $*2
	a.height = $*2
	P_TeleportMove(a, a.x, a.y, a.z)
end

function A_RailRing(actor)
	local p = actor.target.player
	if not p return end
	local a = P_SpawnMobj(actor.target.x, actor.target.y, actor.target.z, MT_RAILPICKUP)
	a.radius = $*2
	a.height = $*2
	P_TeleportMove(a, a.x, a.y, a.z)
end

function A_ScatterRing(actor)
	local p = actor.target.player
	if not p return end
	local a = P_SpawnMobj(actor.target.x, actor.target.y, actor.target.z, MT_SCATTERPICKUP)
	a.radius = $*2
	a.height = $*2
	P_TeleportMove(a, a.x, a.y, a.z)
end

function A_MPRingExplode(mo)
    local tmpsound = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
    tmpsound.state = S_INVISIBLE
    tmpsound.tics = TICRATE
    S_StartSound(tmpsound, sfx_pop)
    local spd = FixedMul(mo.info.painchance, mo.scale)

    for m in mobjs.iterate()
        if m and m.valid and P_AproxDistance(P_AproxDistance(m.x - mo.x, m.y - mo.y), m.z - mo.z) < spd
        and m.flags & MF_SHOOTABLE
            P_DamageMobj(m, mo, mo.target)
        end
    end

    spd = $/mo.scale

    -- spawn particles, but not too many...
    for i = 1, 16
        local g = P_SpawnMobj(mo.x, mo.y, mo.z, MT_BOSSEXPLODE)
        g.target = mo.target
        g.angle = ANG1* (360/(mo.flags2 & MF2_BOUNCERING or mo.flags2 & MF2_AUTOMATIC and 2 or 8))*(i-1)
        g.scale = mo.scale*2
        g.destscale = 1
        g.scalespeed = mo.scale/12
        g.flags2 = mo.flags2 & MF2_OBJECTFLIP
        g.eflags = mo.eflags & MFE_VERTICALFLIP
        g.momx = P_RandomRange(-spd/32, spd/32)*FRACUNIT
        g.momy = P_RandomRange(-spd/32, spd/32)*FRACUNIT
        g.momz = P_RandomRange(-spd/32, spd/32)*FRACUNIT
    end
end

MP_buildMonitor(MT_AUTOMATICMONITOR, MT_AUTOMATICICON, S_AUTOTV, S_AUTOPOP1, SPR_ATTV, SPR_YLTV, A_AutoRing)
MP_buildMonitor(MT_BOUNCEMONITOR, MT_BOUNCEICON, S_BOUNCETV, S_BOUNCEPOP1, SPR_BNTV, SPR_YLTV, A_BounceRing)
MP_buildMonitor(MT_BOMBMONITOR, MT_BOMBICON, S_BOMBTV, S_BOMBPOP1, SPR_BMTV, SPR_YLTV, A_BombRing)
MP_buildMonitor(MT_GRENADEMONITOR, MT_GRENADEICON, S_GRENADETV, S_GRENADEPOP1, SPR_GETV, SPR_FETV, A_GreandeRing)
MP_buildMonitor(MT_INFINITYMONITOR, MT_INFINITYICON, S_INFINITYTV, S_INFINITYPOP1, SPR_IFTV, SPR_YLTV, A_InfinityRing)
MP_buildMonitor(MT_RAILMONITOR, MT_RAILICON, S_RAILTV, S_RAILPOP1, SPR_RLTV, SPR_YLTV, A_RailRing)
MP_buildMonitor(MT_SCATTERMONITOR, MT_SCATTERICON, S_SCATTV, S_SCATPOP1, SPR_SCTV, SPR_YLTV, A_ScatterRing)