-- fitness effect

function A_Fitness(actor)
	if not (actor.target and actor.target.player) return end
	local player = actor.target.player -- it's the fuck who popped the monitor right

	if P_RandomRange(0, 9) == 0
		MP_addGlobalEffect(gef_fitnessgeddon)
		return
	end

	local possibletargets = {}
	for p in players.iterate
		if not p.spectator and p.mo and p.mo.health
			table.insert(possibletargets, p.mo)
		end
	end
	if not #possibletargets
		--print("ERROR: no target avaiable??")
		return
	end
	local targetplayer = possibletargets[P_RandomRange(1, #possibletargets)]
	MP_giveEffect(targetplayer.player, ef_fitness)
end

local function fitthink(mo)
	if not (leveltime%4)
		local drip = MP_spawnParticles(mo, MT_FITNESSPARTICLE, nil, mo.y+P_RandomRange(-25, 25)*mo.scale)
		if drip
			drip.momz = (P_MobjFlip(drip) and -3 or 3)*drip.scale
			drip.destscale = 1
			drip.fuse = 20
		end
	end
end

local function hud_fiticon(v, p, c, t)
	local flag = 0 + max(0, V_10TRANS * ((t-300)/5))
	flag = min(V_90TRANS, $)
	v.draw(0, 0, v.cachePatch("FITNESS"), flag|V_SNAPTOTOP|V_SNAPTOLEFT)
end

local ef_fitness_data = {
	get = 	function()
				S_StartSound(nil, sfx_fit)
			end,

	time = TICRATE*10,
	func = fitthink,
	hudfunc = hud_fiticon,
}
effectList[ef_fitness] = ef_fitness_data

local function hud_ftnicon_scores(v)
	-- the amazing thing with the scoreboard is that it doesn't have a clue what the player is.
	for p in players.iterate	-- so you have to do a manual iteration
		if p ~= lp continue end	-- and we compare players with our local player defined above via a hacky hud hook
		if not p.mo continue end
		if p.mo.MP_effects[ef_fitness]
			local flag = 0 + max(0, V_10TRANS * ((p.mo.MP_effects[ef_blooper]-300)/5))
			flag = min(V_90TRANS, $)
			v.draw(0, 0, v.cachePatch("FITNESS"), flag|V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	end
end
hud.add(hud_ftnicon_scores, "scores")

mobjinfo[MT_MASON] = {
	spawnstate = S_MASON,
	height = 4*FRACUNIT,
	radius = 30*FRACUNIT,
	flags = MF_NOGRAVITY|MF_BOUNCE
}

states[S_MASON] = {SPR_MASO,0}

MP_buildMonitor(MT_FITNESSMONITOR, MT_FITNESSICON, S_FITNESSTV, S_FITNESSPOP1, SPR_FIMT, SPR_FIMT, A_Fitness)

states[S_FITNESSPART1] = {SPR_FIPT, A, 2, nil, 0, 0, S_FITNESSPART2}
states[S_FITNESSPART2] = {SPR_FIPT, TR_TRANS30|A, 2, nil, 0, 0, S_FITNESSPART3}
states[S_FITNESSPART3] = {SPR_FIPT, TR_TRANS60|A, 2, nil, 0, 0, S_FITNESSPART4}
states[S_FITNESSPART4] = {SPR_FIPT, TR_TRANS90|A, 2, nil, 0, 0, S_NULL}

mobjinfo[MT_FITNESSPARTICLE] = {
	doomednum = -1,
    spawnstate = S_FITNESSPART1,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_None,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_NULL,
    painchance = 1,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_None,
    speed = 1*FRACUNIT,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    dispoffset = 1,
    mass = 16,
    damage = 1*FRACUNIT,
    activesound = sfx_None,
    flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT,
    raisestate = MT_THOK
}