freeslot("SPR_HYFR", "S_HYPERFLAME1", "S_HYPERFLAME2", "S_HYPERFLAME3", "S_HYPERFLAME4", "S_HYPERFLAME5", "S_HYPERFLAME6", "MT_HYPERFLAME")

function A_HyperSneakers(actor)
	local p = actor.target.player
	MP_giveEffect(p, ef_hypersneakers)
end

local function efct_hsneakers(mo, inflictor, time)
	if leveltime%2 and not mo.player.powers[pw_super]
		local ghost = P_SpawnGhostMobj(mo)
		ghost.fuse = 8
		ghost.colorized = true
	end
	mo.player.normalspeed = 106*FRACUNIT
	mo.player.actionspd = 130*FRACUNIT

	if P_IsObjectOnGround(mo)
	and mo.player.speed > 78*FRACUNIT
	and not (mo.eflags & MFE_UNDERWATER or mo.eflags & MFE_TOUCHWATER)
		mo.hshoesflicker = $1 + 1
		local spawndistance = 24
			for i =1,2

			local an = R_PointToAngle2(mo.x, mo.y, mo.x+mo.momx, mo.y+mo.momy) + ANGLE_90*i + ANGLE_90*(i-1)    -- im lazy lol
			local sx = mo.x + spawndistance*(cos(an))
			local sy = mo.y + spawndistance*(sin(an))
			local fire = P_SpawnMobj(sx, sy, mo.z, MT_HYPERFLAME)
			fire.state = S_HYPERFLAME1
			fire.fuse = 4*TICRATE
			fire.target = mo
			S_StartSound(mo, sfx_s3k48)
		end

		if mo.hshoesflicker
			if not mo.player.powers[pw_super]
				local superspark = MP_spawnParticles(mo, MT_SUPERPARTICLE)
				if superspark -- make sure it actually spawned under conditions...
					P_SetObjectMomZ(superspark, 2*superspark.scale)
					superspark.color = mo.color
				end

				if mo.hshoesflicker
					mo.colorized = true
				else
					mo.colorized = false
				end

				if mo.hshoesflicker == 1
					mo.color = SKINCOLOR_BLUE
				elseif mo.hshoesflicker == 2
					mo.color = SKINCOLOR_TEAL
				elseif mo.hshoesflicker == 3
					mo.color = SKINCOLOR_CYAN
				end
			end
			
			if mo.hshoesflicker == 4
				mo.hshoesflicker = 0
			end
		end
	else
		if not mo.player.powers[pw_super]
			mo.color = mo.player.skincolor
		end
		mo.colorized = false
	end
end

local hsneakers_data = {
	time = 20*TICRATE,
	func = efct_hsneakers,
	get = function(mo)
				if not mo.player.powers[pw_super]
					P_PlayJingleMusic(mo.player, "HSHOES")
				end	
				mo.hshoesflicker = 0
			end,
	lose = function(mo)
				if not mo.player.powers[pw_super]
					mo.color = mo.player.skincolor
				end
				mo.colorized = false
				mo.player.normalspeed = skins[mo.skin].normalspeed
				mo.player.actionspd = skins[mo.skin].actionspd
				P_RestoreMusic(mo.player)
			end,
	hudico = "HSHOEICO",
}
effectList[ef_hypersneakers] = hsneakers_data

addHook("ShouldDamage", function(mo, inflictor, source)
    if mo and mo.MP_effects and mo.MP_effects[ef_hypersneakers] and mo.player and mo.player.speed > 78*FRACUNIT and inflictor and inflictor.flags & MF_ENEMY and P_IsObjectOnGround(mo)
        P_DamageMobj(inflictor, mo, mo)
        return false
    end
end, MT_PLAYER)

addHook("ShouldDamage", function(mo, inflictor, source)
    if inflictor and inflictor.valid and inflictor.type == MT_HYPERFLAME -- flame object whatever
    and inflictor.target    -- make sure the flame's target is the player mo that spawned it
    and inflictor.target.player and mo.player and friendPlayer(mo.player, inflictor.target.player)
        return false
    end
end, MT_PLAYER)

addHook("HurtMsg", function(p, inflictor, source)

	if not inflictor return end			-- got hit by a ghost nice
	if not inflictor.valid return end	-- got hit by a dead thing nice

	if inflictor.type == MT_HYPERFLAME
	and inflictor.source
		if MP_isDead(p)
			print(p.cname.." was scorched by "..inflictor.source.player.cname.."'s Hyper Sneaker flames!")
			return true
		else
			print(p.cname.." was burned by "..inflictor.source.player.cname.."'s Hyper Sneaker flames.")
			return true
		end
	end
end)

addHook("ShouldJingleContinue", function(p, musname)
	if musname == "HSHOES"
		return p.mo and p.mo.valid and p.mo.MP_effects[ef_hypershoes]
	end
end)

MP_buildMonitor(MT_HYPERSHOESMONITOR, MT_HYPERSHOESICON, S_HSHOTV, S_HSHOPOP1, SPR_HSHO, SPR_HSHO, A_HyperSneakers)

mobjinfo[MT_HYPERFLAME] = {
    spawnstate = S_HYPERFLAME1,
    deathstate = S_HYPERFLAME1,
    radius = 8*FRACUNIT,
    height = 14*FRACUNIT,
    flags = MF_NOGRAVITY|MF_MISSILE|MF_GRENADEBOUNCE,
}

states[S_HYPERFLAME1] = {SPR_HYFR, FF_FULLBRIGHT|A, 2, nil, 0, 0, S_HYPERFLAME2}
states[S_HYPERFLAME2] = {SPR_HYFR, FF_FULLBRIGHT|B, 2, nil, 0, 0, S_HYPERFLAME3}
states[S_HYPERFLAME3] = {SPR_HYFR, FF_FULLBRIGHT|C, 2, nil, 0, 0, S_HYPERFLAME4}
states[S_HYPERFLAME4] = {SPR_HYFR, FF_FULLBRIGHT|D, 2, nil, 0, 0, S_HYPERFLAME5}
states[S_HYPERFLAME5] = {SPR_HYFR, FF_FULLBRIGHT|E, 2, nil, 0, 0, S_HYPERFLAME6}
states[S_HYPERFLAME6] = {SPR_HYFR, FF_FULLBRIGHT|F, 2, nil, 0, 0, S_HYPERFLAME1}