function A_JuggernautDrive(actor)
	local p = actor.target.player
	if not p.mo.MP_effects[ef_juggernautdrive]
		MP_giveEffect(p, ef_juggernautdrive)
	end
end

local function jdriveLightning(mo, arg)	-- Snu, my beloved, it's in times like these you should use functions;
	S_StartSound(nil, _G["sfx_litng"..P_RandomRange(1, 4)])
	S_StartSound(nil, sfx_rumble)
	P_StartQuake(10*FRACUNIT, 100)
	MP_spawnLightning(mo, arg and SKINCOLOR_RED or SKINCOLOR_CYAN, arg and SKINCOLOR_CYAN or SKINCOLOR_RED)
	for p in players.iterate
		P_FlashPal(p, 1, 17)
	end
end
local call = true

freeslot("SPR_NTHK")

local function MP_JDriveLaserThinker(mo)
	local x, y, z = mo.x, mo.y, mo.z

	if mo.momx ~= 0 or mo.momy ~= 0
		if not P_TryMove(mo, mo.x + mo.momx/2, mo.y + mo.momy/2, true) return true end
		if not mo.valid return true end
	end

	if mo.momz ~= 0
		mo.z = $ + mo.momz/2
		if mo.z < mo.floorz or mo.z + mo.height > mo.ceilingz return true end
	end

	return not mo.valid or x == mo.x and y == mo.y and z == mo.z
end

local function MP_JDriveLaser(mo, long)
	local nblockmap = not (mo.flags & MF_NOBLOCKMAP)

	for i = 0, 512
		if nblockmap
			mo.flags = $ | MF_NOBLOCKMAP
		end

		local p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.scale = mo.scale
		p.destscale = 1
		p.scalespeed = mo.scale/12
		p.sprite = SPR_NTHK
		p.frame = A
		p.color = i%2 and SKINCOLOR_CYAN or SKINCOLOR_RED
		p.tics = TICRATE

		p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.scale = mo.scale*3/2
		p.destscale = 1
		p.sprite = SPR_NTHK
		p.frame = A|TR_TRANS80
		p.scalespeed = mo.scale/12
		p.color = SKINCOLOR_WHITE
		p.tics = TICRATE

		if MP_JDriveLaserThinker(mo)
			break
		end
	end
	A_MPRingExplode(mo)
	P_ExplodeMissile(mo)
end

local atk4_unlock = 60

local function MP_JdriveInput(mo)
	local cmd = mo.player.cmd.buttons

	local jdmaxwpn = mo.jd_counts >= atk4_unlock and 4 or 3

	if mo.jd_weapondelay
		mo.jd_weapondelay = $-1
	end

	if cmd & BT_ATTACK
		if not mo.jd_cmdatk
			mo.jd_cmdatk = 0
		end
		mo.jd_cmdatk = $+1
		if not mo.jd_weapondelay and mo.jd_cmdatk == 1
			return mo.jd_weapon
		end
	else
		mo.jd_cmdatk = 0
	end

	if cmd & BT_WEAPONNEXT or cmd & BT_WEAPONPREV
		if not mo.jd_cmdwpnswitch
			mo.jd_cmdwpnswitch = 0
		end
		mo.jd_cmdwpnswitch = $+1
	else
		mo.jd_cmdwpnswitch = 0
	end
	if mo.jd_cmdwpnswitch == 1
		if cmd & BT_WEAPONNEXT
			mo.jd_weapon = mo.jd_weapon < jdmaxwpn and $+1 or 1
		else
			mo.jd_weapon = mo.jd_weapon > 1 and $-1 or jdmaxwpn
		end
	end
end

local function MP_JdriveMain(mo)

	if not (leveltime%TICRATE)
		if mo.player.rings < 1 -- no rings left, welcome to die
			if mo.jd_counts >= atk4_unlock -- special sound if you can use long anus smasher
				S_StartSound(nil, sfx_nodra3)
			else
				if mo.jd_lockstate -- special sound if you're using an attack
				and mo.jd_lockstate < 3
					S_StartSound(nil, sfx_nodra2)
				else -- ALL HAIL GRABBIN DRAGON
					S_StartSound(nil, sfx_grabdr)
				end
			end
			P_KillMobj(mo, nil, nil)
			return -- he was a noble sacrifice
		else
			if not mo.jdrivedone
				if mo.jd_counts >= atk4_unlock
					P_GivePlayerRings(mo.player, -2-((mo.jd_counts-60)/15)*2) -- holy fuck nuggets
				else
					P_GivePlayerRings(mo.player, -1)
				end
			end
		end
		if not mo.jd_counts
			mo.jd_counts = 0
		end
		mo.jd_counts = $+1
	end

	mo.player.weapondelay = TICRATE*2

	-- lockstates: for continous attacks
	if mo.jd_lockstate
		mo.player.pflags = $ & ~(PF_SPINNING|PF_JUMPED)

		if mo.jd_lockstate == 3	--LONGANUS SMASHER
			mo.momz = 0
			P_InstaThrust(mo, 0, 0)
			mo.jd_anussmashertimer = $+1
			if mo.jd_anussmashertimer <= 29
				mo.state = S_PLAY_FALL
				mo.sprite2 = SPR2_TRNS
				mo.frame = A
				mo.momz = 0
				P_InstaThrust(mo,0,0)
			elseif mo.jd_anussmashertimer <= 39
				mo.state = S_PLAY_FALL
				mo.sprite2 = SPR2_TRNS
				mo.frame = B
			elseif mo.jd_anussmashertimer == 52
				for i = 1, 256
					local explosion = P_SpawnMobj(mo.x+P_RandomRange(-20, 20)*mo.scale, mo.y+P_RandomRange(-20, 20)*mo.scale, mo.z+P_RandomRange(0, 40)*mo.scale, MT_THOK)
					explosion.scale = mo.scale/2
					explosion.destscale = FRACUNIT
					explosion.tics = 2*TICRATE
					explosion.momx = P_RandomRange(-30, 30)*mo.scale
					explosion.momy = P_RandomRange(-30, 30)*mo.scale
					explosion.momz = P_RandomRange(0, 20)*mo.scale
					explosion.scalespeed = FRACUNIT/18
					explosion.flags = $|(MF_NOCLIPTHING)
					explosion.color = i%2 and SKINCOLOR_CYAN or SKINCOLOR_RED
				end
			elseif mo.jd_anussmashertimer <= 52 + TICRATE*6
				mo.state =  S_PLAY_FALL
				mo.sprite2 = SPR2_TRNS
				mo.frame = mo.jd_anussmashertimer <= 52 + TICRATE*6 + 5 and G or D

				if not (leveltime%5)
					local msl = P_SpawnPlayerMissile(mo, MT_JDRIVELASER, MF2_EXPLOSION)
					if msl
						msl.drainrings = true	-- used to know if we must damage normally or drain rings.
						MP_JDriveLaser(msl, true)
					end
				end
			elseif mo.jd_anussmashertimer <= 52 + TICRATE*6 + TICRATE*4
				mo.destscale = FRACUNIT
				mo.scalespeed = FRACUNIT/65
				mo.jdrivedone = true
				mo.color = mo.player.skincolor
				mo.state = S_PLAY_FALL
			else
				MP_loseEffect(mo.player, ef_juggernautdrive)
			end

		elseif mo.jd_lockstate == 1 -- EXPLOSION
			mo.jd_explosiontimer = $+1
			if mo.jd_explosiontimer >= 1 and mo.jd_explosiontimer <= 70
				mo.state = S_PLAY_SUPER_TRANS1
			elseif mo.jd_explosiontimer >= 71 and mo.jd_explosiontimer <= 74
				mo.state = S_PLAY_SUPER_TRANS2
			elseif mo.jd_explosiontimer == 75
				local modifier = (mo.player.powers[pw_super]) and FRACUNIT*5 or FRACUNIT*3
				local range = FixedMul(modifier, 1536*FRACUNIT)	-- nuke range, but BIGGER
						
				S_StartSound(nil, sfx_sexiki)
				P_StartQuake(28*FRACUNIT, 5)
				
				for breastdragonemperor in players.iterate
					P_FlashPal(breastdragonemperor, 10, 13)
					if (breastdragonemperor == mo.player) then continue end
						
					if (breastdragonemperor.mo and breastdragonemperor.mo.valid)
					and (breastdragonemperor.mo.health)
					and not breastdragonemperor.spectator
						if R_PointToDist2(mo.x, mo.y, breastdragonemperor.mo.x, breastdragonemperor.mo.y) > range continue end
							
						-- Kill players if you're super
						local fn = mo.player.powers[pw_super] and P_KillMobj or P_DamageMobj
							
						if breastdragonemperor.mo.MP_effects[ef_hyper]
						and mo.player.powers[pw_super]
							breastdragonemperor.rings = 0
							print(breastdragonemperor.cname.." was hit by "..mo.player.cname.."'s explosion and used all their power to withstand it!")
						else	
							fn(breastdragonemperor.mo, mo, mo)
							
							if mo.player.powers[pw_super]
								print(breastdragonemperor.cname.." was hit by "..mo.player.cname.."'s explosion, and was killed instantly.")
							else
								if MP_isDead(breastdragonemperor)
									print(breastdragonemperor.cname.." was killed by "..mo.player.cname.."'s explosion!")
								else
									print(breastdragonemperor.cname.." was hit by "..mo.player.cname.."'s explosion!")
								end
							end						
							breastdragonemperor.mo.MP_nohurtmsg = false
						end
							
						P_InstaThrust(breastdragonemperor.mo, R_PointToAngle2(mo.x, mo.y, breastdragonemperor.mo.x, breastdragonemperor.mo.y), 5*FRACUNIT)
						P_SetObjectMomZ(breastdragonemperor.mo, 19*FRACUNIT)
						P_SpawnMobj(breastdragonemperor.mo.x, breastdragonemperor.mo.y, breastdragonemperor.mo.z, MT_DRAGONEXPL)
					end
				end

				for allhailgrabbindragon in mobjs.iterate()
					if allhailgrabbindragon.flags & (MF_ENEMY|MF_BOSS)
						if R_PointToDist2(mo.x, mo.y, allhailgrabbindragon.x, allhailgrabbindragon.y) > range continue end
						P_KillMobj(allhailgrabbindragon, mo, mo)
					end
				end

				for i = 1, 256
					local explosion = P_SpawnMobj(mo.x+P_RandomRange(-20, 20)*mo.scale, mo.y+P_RandomRange(-20, 20)*mo.scale, mo.z+P_RandomRange(0, 40)*mo.scale, MT_THOK)
					explosion.scale = mo.scale/2
					explosion.destscale = FRACUNIT
					explosion.tics = 2*TICRATE
					explosion.momx = P_RandomRange(-30, 30)*mo.scale
					explosion.momy = P_RandomRange(-30, 30)*mo.scale
					explosion.momz = P_RandomRange(0, 20)*mo.scale
					explosion.scalespeed = FRACUNIT/18
					explosion.glowcolor = P_RandomRange(1, 2)
					explosion.flags = $|(MF_NOCLIPTHING)
					if explosion.glowcolor == 1 then explosion.color = SKINCOLOR_CYAN end
					if explosion.glowcolor == 2 then explosion.color = SKINCOLOR_RED end
				end
			elseif mo.jd_explosiontimer >= 75 and mo.jd_explosiontimer <= 78
				mo.state = S_PLAY_SUPER_TRANS3
			elseif mo.jd_explosiontimer >= 79 and mo.jd_explosiontimer <= 183
				mo.state = S_PLAY_SUPER_TRANS4
			elseif mo.jd_explosiontimer >= 184
				mo.state = S_PLAY_FALL
				mo.jd_lockstate = nil
				mo.jd_explosiontimer = nil
				mo.jd_weapondelay = TICRATE*2
			end
		elseif mo.jd_lockstate == 2 -- DIVIDE!!!!!!
			for dp in players.iterate
				if dp ~= mo.player
					if (dp.mo and dp.mo.health) and not dp.spectator
					and R_PointToDist2(mo.x, mo.y, dp.mo.x, dp.mo.y) <= 256*FRACUNIT -- if they're closeby
						P_DoPlayerPain(dp)
						MP_giveEffect(dp, ef_divided)
						MP_giveEffect(mo.player, ef_divider)
					end
				end
			end
			mo.jd_lockstate = nil
			mo.jd_weapondelay = TICRATE*2
		end
		return
	end
	local atkn = MP_JdriveInput(mo)	-- returns true if we attacked (and can attack) and also handles all input.
	if atkn == 1	-- jdrive laser
		-- fire laser
		mo.jd_weapondelay = TICRATE/2
		local msl = P_SpawnPlayerMissile(mo, MT_JDRIVELASER, MF2_EXPLOSION)
		if not msl return end
		MP_JDriveLaser(msl, true)
		if mo.player.powers[pw_super]
			P_GivePlayerRings(mo.player, -5)
		else
			P_GivePlayerRings(mo.player, -3)
		end
	elseif atkn == 2	-- divide
		if mo.candivide
			mo.jd_lockstate = 2
			S_StartSound(mo, sfx_divide)	-- DIVIDE SOUND GOES HERE
			if mo.player.powers[pw_super]
				P_GivePlayerRings(mo.player, -11)
			else
				P_GivePlayerRings(mo.player, -7)
			end
		end
	elseif atkn == 3	-- jdrive explosion
		if (mo.player.pflags & PF_JUMPED)
		and (mo.player.pflags != PF_ROPEHANG)
		and (mo.player.pflags != PF_MACESPIN)
		and (mo.player.pflags & PF_JUMPED)
			mo.jd_explosiontimer = 0
			mo.jd_lockstate = 1
			S_StartSound(nil, sfx_explos)
			S_StartSound(nil, sfx_rumble)
			P_StartQuake(30*FRACUNIT, 78)
			if mo.player.powers[pw_super]
				P_GivePlayerRings(mo.player, -15)
			else
				P_GivePlayerRings(mo.player, -10)
			end
		end
	elseif atkn == 4
		if (mo.player.pflags & PF_JUMPED)
		and (mo.player.pflags != PF_ROPEHANG)
		and (mo.player.pflags != PF_MACESPIN)
		and (mo.player.pflags & PF_JUMPED)
			S_StartSound(mo, sfx_lngins)
			mo.jd_lockstate = 3
			mo.jd_anussmashertimer = 0
		end
	end
end

local function efct_jdrive(mo, inflictor, time)

	if time > 0
		if time >= 100
		and not mo.jdrivedone
			if time <= 838 -- particles
				local hyperspark = MP_spawnParticles(mo, MT_HYPERPARTICLE, mo.x+P_RandomRange(30, -30)*mo.scale, mo.y+P_RandomRange(30, -30)*mo.scale, mo.z)
				if hyperspark -- make sure it actually spawned under conditions...
					P_SetObjectMomZ(hyperspark, 5*FRACUNIT)
					hyperspark.scalespeed = hyperspark.scale/18
					hyperspark.destscale = 1
					hyperspark.scale = mo.scale/2
					hyperspark.glowcolour = P_RandomRange(1, 4)
					local g = hyperspark.glowcolour
					hyperspark.color = (g == 1 and SKINCOLOR_CYAN) or (g == 2 and SKINCOLOR_RED) or (g == 3 and SKINCOLOR_CRIMSON) or (g == 4 and SKINCOLOR_TEAL)
				end
				local superspark = MP_spawnParticles(mo, MT_SUPERPARTICLE, mo.x+P_RandomRange(15, -15)*mo.scale, mo.y+P_RandomRange(15, -15)*mo.scale, mo.z)
				if superspark -- make sure it actually spawned under conditions...
					P_SetObjectMomZ(superspark, 5*FRACUNIT)
					superspark.destscale = 1
					superspark.scalespeed = superspark.scale/18
					superspark.glowcolour = P_RandomRange(1, 4)
					local g = superspark.glowcolour
					superspark.color = (g == 1 and SKINCOLOR_CYAN) or (g == 2 and SKINCOLOR_RED) or (g == 3 and SKINCOLOR_CRIMSON) or (g == 4 and SKINCOLOR_TEAL)
				end
			else
				local hyperspark = MP_spawnParticles(mo, MT_HYPERPARTICLE, mo.x+P_RandomRange(30, -30)*mo.scale, mo.y+P_RandomRange(30, -30)*mo.scale, mo.z)
				if hyperspark -- make sure it actually spawned under conditions...
					P_SetObjectMomZ(hyperspark, 20*FRACUNIT)
					hyperspark.scalespeed = hyperspark.scale/18
					hyperspark.destscale = 1
					hyperspark.glowcolour = P_RandomRange(1, 4)
					local g = hyperspark.glowcolour
					hyperspark.color = (g == 1 and SKINCOLOR_CYAN) or (g == 2 and SKINCOLOR_RED) or (g == 3 and SKINCOLOR_CRIMSON) or (g == 4 and SKINCOLOR_TEAL)
				end
				local superspark = MP_spawnParticles(mo, MT_SUPERPARTICLE, mo.x+P_RandomRange(15, -15)*mo.scale, mo.y+P_RandomRange(15, -15)*mo.scale, mo.z)
				if superspark -- make sure it actually spawned under conditions...
					P_SetObjectMomZ(superspark, 20*FRACUNIT)
					superspark.destscale = 1
					superspark.scalespeed = superspark.scale/18
					superspark.glowcolour = P_RandomRange(1, 4)
					local g = superspark.glowcolour
					superspark.color = (g == 1 and SKINCOLOR_CYAN) or (g == 2 and SKINCOLOR_RED) or (g == 3 and SKINCOLOR_CRIMSON) or (g == 4 and SKINCOLOR_TEAL)
				end
			end
		end
		if not mo.jdriveboosted
			if time <= 945 -- animation stuff
				if not (time%100)
					jdriveLightning(mo, call)
					call = not call
					if time == 100
						P_SetupLevelSky(668, nil)
						P_SwitchWeather(PRECIP_STORM_NORAIN, nil)
					end
				end

				if time <= 835
					mo.state = S_PLAY_SUPER_TRANS1
					mo.frame = A
				elseif time <= 838
					mo.state = S_PLAY_SUPER_TRANS2
					mo.frame = B
				elseif time <= 844
					mo.state = S_PLAY_SUPER_TRANS3
					mo.frame = C
				elseif time <= 945
					mo.state = S_PLAY_SUPER_TRANS4
					mo.frame = D
				end

				if time == 770
					mo.megido_stars = {}
					for i=1,6
						local megidostars = P_SpawnMobj(mo.x, mo.y, mo.z+400*FRACUNIT, MT_THOK)
						megidostars.frame = A
						megidostars.tics = -1
						megidostars.scale = 1
						megidostars.destscale = FRACUNIT*2
						megidostars.scalespeed = $/2
						megidostars.zp = 400*FRACUNIT
						megidostars.flags = MF_NOGRAVITY
						megidostars.flags = $|(MF_NOCLIPTHING)
						table.insert(mo.megido_stars, megidostars)
						megidostars.glowcolor = P_RandomRange(1, 2)
						if megidostars.glowcolor == 1 then megidostars.color = SKINCOLOR_CYAN end
						if megidostars.glowcolor == 2 then megidostars.color = SKINCOLOR_RED end
					end
				elseif time >= 835
					for k,v in ipairs(mo.megido_stars)
						v.state = S_NULL
						table.remove(mo.megido_stars, k)
					end
				elseif time > 770 and time <= 835
					for k,v in ipairs(mo.megido_stars)
						
						if v and v.valid
						
							P_SpawnGhostMobj(v)
							v.frame = A|FF_FULLBRIGHT
							local dist = (v.z-v.floorz)*3/3
							local gotox = mo.x + (dist/FRACUNIT)* (cos ( ( k-1 )*ANG60 + (ANG1*10)*time))
							local gotoy = mo.y + (dist/FRACUNIT)*(sin((k-1)*ANG60 + (ANG1*10)*time))
							if v.z > 0
								v.momz = -7*FRACUNIT
							else
								v.momz = 0
							end
							v.zp = $1 - 30*FRACUNIT
							P_TeleportMove(v, gotox, gotoy, v.z)
						end	
					end
				end
				if time >= 838
					local jdrivecolours = {SKINCOLOR_BLUE, SKINCOLOR_TEAL, SKINCOLOR_CYAN, SKINCOLOR_WHITE, SKINCOLOR_TAN, SKINCOLOR_RED, SKINCOLOR_CRIMSON, SKINCOLOR_RED, SKINCOLOR_TAN, SKINCOLOR_WHITE, SKINCOLOR_CYAN, SKINCOLOR_TEAL}
					local colour = jdrivecolours[((leveltime /2) or 1)%(#jdrivecolours)+1]
					mo.color = colour or $
					local ghost = P_SpawnGhostMobj(mo)
					ghost.fuse = 6
					if mo.player.rings < 75
						P_GivePlayerRings(mo.player, 1)
						S_StartSound(mo, sfx_itemup, mo.player)
					end
				end
				if time == 838
					for ahgj in players.iterate
						P_FlashPal(ahgj, 10, 13)
					end
					S_StartSound(nil, sfx_sexiki)
					P_SwitchWeather(PRECIP_STORM, nil)
					P_StartQuake(50*FRACUNIT, 70)

					for i = 1, 256
						local explosion = P_SpawnMobj(mo.x+P_RandomRange(-20, 20)*mo.scale, mo.y+P_RandomRange(-20, 20)*mo.scale, mo.z+P_RandomRange(0, 40)*mo.scale, MT_THOK)
						explosion.scale = mo.scale/2
						explosion.destscale = FRACUNIT
						explosion.tics = 2*TICRATE
						explosion.momx = P_RandomRange(-30, 30)*mo.scale
						explosion.momy = P_RandomRange(-30, 30)*mo.scale
						explosion.momz = P_RandomRange(0, 20)*mo.scale
						explosion.scalespeed = FRACUNIT/18
						explosion.glowcolor = P_RandomRange(1, 2)
						explosion.flags = $|(MF_NOCLIPTHING)
						if explosion.glowcolor == 1 then explosion.color = SKINCOLOR_CYAN end
						if explosion.glowcolor == 2 then explosion.color = SKINCOLOR_RED end
					end

					P_StartQuake(28*FRACUNIT, 5)
					
					for breastdragonemperor in players.iterate
						P_FlashPal(breastdragonemperor, 10, 13)
						if (breastdragonemperor == mo.player) then continue end
						
						if (breastdragonemperor.mo and breastdragonemperor.mo.valid)
						and (breastdragonemperor.mo.health)
						and not breastdragonemperor.spectator
							
							local range = mo.player.powers[pw_super] and 5669 or 3069
							if R_PointToDist2(mo.x, mo.y, breastdragonemperor.mo.x, breastdragonemperor.mo.y) > (mo.scale/3)*range continue end
							
							-- Kill players if you're super
							local fn = mo.player.powers[pw_super] and P_KillMobj or P_DamageMobj
							
							if breastdragonemperor.mo.MP_effects[ef_hyper]
							and mo.player.powers[pw_super]
								breastdragonemperor.rings = 0
								print(breastdragonemperor.cname.." was hit by "..mo.player.cname.."'s explosion and used all their power to withstand it!")
							else	
								fn(breastdragonemperor.mo, mo, mo)
								
								if mo.player.powers[pw_super]
									print(breastdragonemperor.cname.." was hit by "..mo.player.cname.."'s explosion, and was killed instantly.")
								else
									if MP_isDead(breastdragonemperor)
										print(breastdragonemperor.cname.." was killed by "..mo.player.cname.."'s explosion!")
									else
										print(breastdragonemperor.cname.." was hit by "..mo.player.cname.."'s explosion!")
									end
								end						
								breastdragonemperor.mo.MP_nohurtmsg = false
							end
							
							P_InstaThrust(breastdragonemperor.mo, R_PointToAngle2(mo.x, mo.y, breastdragonemperor.mo.x, breastdragonemperor.mo.y), 5*FRACUNIT)
							P_SetObjectMomZ(breastdragonemperor.mo, 19*FRACUNIT)
							P_SpawnMobj(breastdragonemperor.mo.x, breastdragonemperor.mo.y, breastdragonemperor.mo.z, MT_DRAGONEXPL)
						end
					end

					for allhailgrabbindragon in mobjs.iterate()
						if allhailgrabbindragon.flags & (MF_ENEMY|MF_BOSS)
							P_KillMobj(allhailgrabbindragon, mo, mo)
						end
					end
				end
			else
				mo.player.pflags = $1 & ~PF_GODMODE
				mo.jdriveboosted = true
				mo.state = S_PLAY_FALL
			end
		else
			if not mo.jdrivedone
				local jdrivecolours = {SKINCOLOR_BLUE, SKINCOLOR_TEAL, SKINCOLOR_CYAN, SKINCOLOR_WHITE, SKINCOLOR_TAN, SKINCOLOR_RED, SKINCOLOR_CRIMSON, SKINCOLOR_RED, SKINCOLOR_TAN, SKINCOLOR_WHITE, SKINCOLOR_CYAN, SKINCOLOR_TEAL}
				local colour = jdrivecolours[((leveltime /2) or 1)%(#jdrivecolours)+1]
				mo.color = colour or $

				if leveltime%2
					local ghost = P_SpawnGhostMobj(mo)
					ghost.fuse = 6
					ghost.colorized = true
				end
			end
			MP_JdriveMain(mo)
			for dp in players.iterate
				if (dp.mo and dp.mo.health) and dp ~= mo.player
					if R_PointToDist2(mo.x, mo.y, dp.mo.x, dp.mo.y) <= 256*FRACUNIT -- if they're closeby
						mo.candivide = true -- just doing this so you arent earraped ***DIVIDE!!!!!!!!!!***
						break
					else
						mo.candivide = nil
					end
				end
			end
		end
	end
end

local jdrive_data = {
	func = efct_jdrive,
	get = function(mo)
					
					if mo.player == consoleplayer
						hud.disable("weaponrings")
					end
					
					S_StartSound(mo, sfx_jdrive)
					S_StartSound(nil, sfx_rumble)
					P_StartQuake(10*FRACUNIT, 100)
					mo.scale = FRACUNIT*1
					mo.destscale = FRACUNIT*3
					mo.scalespeed = FRACUNIT/415
					--mo.player.pflags = $1|PF_GODMODE
					mo.jd_weapon = 1
					mo.jd_weapondelay = 0
					mo.jd_counts = 0
					P_PlayJingleMusic(nil, "JDRIVE")
					for p in players.iterate
						if p ~= mo.player
							COM_BufInsertText(p, "cecho "..mo.player.name.." \\is charging their Juggernaut Drive!")
							S_StartSound(nil, sfx_strpst)
						end
					end
				end,
	lose = function(mo)
	
					if mo.player == consoleplayer
						hud.enable("weaponrings")
					end
	
					if MP_isDead(mo.player)
						if mo.jd_counts >= atk4_unlock -- special sound if you can use long anus smasher
							S_StartSound(nil, sfx_nodra3)
						else
							if mo.jd_lockstate -- special sound if you're using an attack
							and mo.jd_lockstate < 3
								S_StartSound(nil, sfx_nodra2)
							else -- ALL HAIL GRABBIN DRAGON
								S_StartSound(nil, sfx_grabdr)
							end
						end
					else
						if mo.mp_cutoff_hyper
							mo.mp_cutoff_hyper = nil
							mo.player.rings = max($, 100)
							mo.MP_effects[ef_hyper] = 1
						end
					end
					
					mo.jd_lockstate = nil
					mo.candivide = nil
					mo.jd_explosiontimer = nil
					mo.jd_weapondelay = nil
					mo.jdriveboosted = nil
					mo.jd_weapon = nil
					mo.jd_counts = nil
					mo.jd_anussmashertimer = nil
					mo.jd_explosiontimer = nil
					mo.jdrivedone = nil
					mo.scale = FRACUNIT
					mo.color = mo.player.skincolor
					mo.candivide = nil
					for p in players.iterate
						P_RestoreMusic(p)
					end
					P_SwitchWeather(mapheaderinfo[gamemap].weather, nil)
					P_SetupLevelSky(mapheaderinfo[gamemap].skynum, nil)
				end,
	hudfunc = function(v,p,c,t)
					if not p.mo return end
					if not p.mo.jdriveboosted return end
					if p.mo.jdrivedone return end
					local mo = p.mo
					for i = 1, 4
						local flag=0
						if mo.jd_weapondelay
						or mo.jd_lockstate
							flag = V_70TRANS
						end
						if i == 2 and not mo.candivide
							flag = V_70TRANS
						end
						if i == 3 and not ((mo.player.pflags & PF_JUMPED) and (mo.player.pflags != PF_ROPEHANG) and (mo.player.pflags != PF_MACESPIN) and (mo.player.pflags & PF_JUMPED))
							flag = V_70TRANS
						end
						if i == 4
							if (mo.jd_counts and mo.jd_counts < atk4_unlock or not mo.jd_counts)
							or not ((mo.player.pflags & PF_JUMPED) and (mo.player.pflags != PF_ROPEHANG) and (mo.player.pflags != PF_MACESPIN) and (mo.player.pflags & PF_JUMPED))
								flag = V_70TRANS
							end
						end
						v.drawScaled((94 + 32*(mo.jd_weapon-1))*FRACUNIT, 170*FRACUNIT, FRACUNIT + FRACUNIT*40/100, v.cachePatch("CURWEAP"), V_SNAPTOBOTTOM)
						v.draw(96 + 32*(i-1), 172, v.cachePatch("JDRIVE"..i), V_SNAPTOBOTTOM|flag)
						if i == 4
						and mo.jd_counts < 60
							v.drawString(94 + 32*(i-1) + 14, 172+6, (60-mo.jd_counts), V_HUDTRANSHALF|V_SNAPTOBOTTOM, "center")
						end
					end
				end,
	hudico = "JDRICO",
}
effectList[ef_juggernautdrive] = jdrive_data

addHook("MobjDamage", function(mo)
	if (mo and mo.valid)
	and mo.MP_effects[ef_juggernautdrive]
		
		if mo.MP_effects[ef_juggernautdrive] < 838
			return true	-- don't damage
		end
		
		P_GivePlayerRings(mo.player, -10)
		S_StartSound(mo, sfx_breast)
		mo.player.powers[pw_flashing] = TICRATE*2-1
		return true
	end
end, MT_PLAYER)

addHook("ShouldJingleContinue", function(p, musname)
	if musname == "JDRIVE"
		for p2 in players.iterate do
			if p2 and p2.mo and p2.mo.valid and p2.mo.MP_effects[ef_juggernautdrive] return true end
		end
	end
end)

local divided_data = {
	time = 15*TICRATE,
	func = function(mo)
				mo.player.jumpfactor = skins[mo.skin].jumpfactor/2
				mo.player.normalspeed = skins[mo.skin].normalspeed/2
				mo.player.actionspd = skins[mo.skin].actionspd/2
			end,
	lose = function(mo)
				mo.player.jumpfactor = skins[mo.skin].jumpfactor
				mo.player.normalspeed = skins[mo.skin].normalspeed
				mo.player.actionspd = skins[mo.skin].actionspd
			end,
	hudico = "IC_DIV",
}
effectList[ef_divided] = divided_data

local divider_data = {
	time = 15*TICRATE,
	func = function(mo)
				mo.player.jumpfactor = skins[mo.skin].jumpfactor*2
				mo.player.normalspeed = skins[mo.skin].normalspeed*2
				mo.player.actionspd = skins[mo.skin].actionspd*2
			end,
	lose = function(mo)
				mo.player.jumpfactor = skins[mo.skin].jumpfactor
				mo.player.normalspeed = skins[mo.skin].normalspeed
				mo.player.actionspd = skins[mo.skin].actionspd
			end,
	hudico = "IC_DIVR",
}
effectList[ef_divider] = divider_data

sfxinfo[sfx_jdrive] = {
        singular = false,
        priority = 64,
        flags = SF_X4AWAYSOUND|SF_X8AWAYSOUND|SF_X2AWAYSOUND
}
sfxinfo[sfx_divide] = {
        singular = false,
        priority = 64,
        flags = SF_X4AWAYSOUND|SF_X8AWAYSOUND|SF_X2AWAYSOUND
}
sfxinfo[sfx_lngins] = {
        singular = false,
        priority = 64,
        flags = SF_X4AWAYSOUND|SF_X8AWAYSOUND|SF_X2AWAYSOUND
}

MP_buildMonitor(MT_JDRIVEMONITOR, MT_JDRIVEICON, S_JDRIVETV, S_JDRIVEPOP1, SPR_JGDR, SPR_JGDR, A_JuggernautDrive)

freeslot("MT_JDRIVELASER")
mobjinfo[MT_JDRIVELASER] = {
	doomednum = -1,
    spawnstate = mobjinfo[MT_THROWNEXPLOSION].spawnstate,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_s3k54,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_NULL,
    painchance = mobjinfo[MT_THROWNEXPLOSION].painchance,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_None,
    speed = mobjinfo[MT_THROWNEXPLOSION].speed,
    radius = mobjinfo[MT_THROWNEXPLOSION].radius,
    height =  mobjinfo[MT_THROWNEXPLOSION].height,
    dispoffset = 1,
    mass = 16,
    damage = 1*FRACUNIT,
    activesound = sfx_None,
    flags = mobjinfo[MT_THROWNEXPLOSION].flags,
}