function A_JumpHeight(actor)
	local p = actor.target.player
	MP_giveEffect(p, ef_jumpheight)
end

local jumphi_data = {
	time = 20*TICRATE,
	func = function(mo, inflictor, time)
			mo.player.jumpfactor = skins[mo.skin].jumpfactor * 2
			local jumppart = MP_spawnParticles(mo, MT_JUMPPARTICLE)
			if jumppart -- make sure it actually spawned under conditions...
				P_SetObjectMomZ(jumppart, 5*jumppart.scale)
				jumppart.destscale = 1
				jumppart.fuse = 30
			end
		end,
	get = function(mo)
				S_StartSound(mo, sfx_cdjump)
				if mo.player.powers[pw_super] == 0
					P_PlayJingleMusic(mo.player, "JUMPS")
				end	
			end,
	lose = function(mo)
				mo.player.jumpfactor = skins[mo.skin].jumpfactor
				P_RestoreMusic(mo.player)
				mo.color = mo.player.skincolor	
				mo.colorized = false
			end,
	hudico = "JUICON",
}
effectList[ef_jumpheight] = jumphi_data

local function resetJumpHeight(mo)
	if not mo.jumpon return end
	mo.player.jumpfactor = skins[mo.skin].jumpfactor
end

addHook("ShouldJingleContinue", function(p, musname)
	if musname == "JUMPS"
		return p.mo and p.mo.valid and p.mo.MP_effects[ef_jumpheight]
	end
end)

addHook("MapLoad", function(gamemap)
	for p in players.iterate
		if p.mo
			p.jumpfactor = skins[p.mo.skin].jumpfactor
		else
			p.jumpfactor = skins[0].jumpfactor
		end
	end
end)

addHook("MobjDeath", resetJumpHeight, MT_PLAYER)

MP_buildMonitor(MT_JUMPMONITOR, MT_JUMPICON, S_JUMPTV, S_JUMPPOP1, SPR_JUTV, SPR_JUTV, A_JumpHeight)

states[S_JUMPPART1] = {SPR_JUPT, A, 2, nil, 0, 0, S_JUMPPART2}
states[S_JUMPPART2] = {SPR_JUPT, TR_TRANS30|A, 2, nil, 0, 0, S_JUMPPART3}
states[S_JUMPPART3] = {SPR_JUPT, TR_TRANS60|A, 2, nil, 0, 0, S_JUMPPART4}
states[S_JUMPPART4] = {SPR_JUPT, TR_TRANS90|A, 2, nil, 0, 0, S_NULL}

mobjinfo[MT_JUMPPARTICLE] = {
	doomednum = -1,
    spawnstate = S_JUMPPART1,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_None,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_NULL,
    painchance = 1,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_None,
    speed = 1*FRACUNIT,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    dispoffset = 1,
    mass = 16,
    damage = 1*FRACUNIT,
    activesound = sfx_None,
    flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT,
    raisestate = MT_THOK
}