-- Re: Megidolaon! >>> A weapon to surpass Duon Calvo (tm)!
freeslot("sfx_mcut", "sfx_megir", "sfx_zio5")

local stars = {}
local smoke = {}

local function megido_think(mo, inflictor, t)
	local p = mo.player
	p.powers[pw_nocontrol] = 32768
	if t == TICRATE/3
		for i = 1,16
			stars[i].cframe = 1
		end
		smoke = {}
		S_StartSound(nil, sfx_mcut, p)
	elseif t == 50
		S_StartSound(nil, sfx_megir, p)
	elseif t == 135
		S_StartSound(nil, sfx_zio5, p)
	elseif t == 180
		S_StartSound(nil, sfx_meboom, p)
	elseif t == 250
		--HU_explosion(p)
		P_FlashPal(p, 1, 2)
	elseif t == 285
		p.powers[pw_nocontrol] = 0
		HU_fade(p)
		mo.MP_nohusrtmsg = true

		local phyper = p.mo.MP_effects[ef_hyper]
		local psuper = p.powers[pw_super]
		
		if phyper
			if inflictor and inflictor.valid
				print(mo.player.cname.." nullified "..inflictor.player.cname.."'s Megidolaon!")
			end
		elseif psuper
			p.rings = 2
			p.powers[pw_flashing] = TICRATE*3 -1

			if inflictor and inflictor.valid
				print(mo.player.cname.." used all of their power to withstand "..inflictor.player.cname.."'s Megidolaon!")
				P_AddPlayerScore(inflictor.player, 50)
			end
		else
			P_KillMobj(mo, inflictor, inflictor)
			
			if inflictor and inflictor.valid
				print(mo.player.cname.." was obliterated by "..inflictor.player.cname.."'s Megidolaon!")
				P_AddPlayerScore(inflictor.player, 100)
			end
		end
		mo.MP_nohurtmsg = false
	
	elseif t == TICRATE*9
		MP_loseEffect(p, ef_megidolaon)
		return
		
	elseif t > TICRATE*5
		p.powers[pw_nocontrol] = 32768
	end
end

-- I steal my own scripts!
local cutinStart = TICRATE*3/2
local cutinframetime = {0, -3, -5, -18, -20, -22, -24}

-- generate positions for the stars, I suppose:
for i = 1, 16
	stars[i] = {
		x = N_RandomRange(10, 300),
		y = N_RandomRange(10, 190),
		maxframe = N_RandomRange(1, 3),
		cframe = 1,
	}
end

local function spawnSmoke(x, y, scale)
	smoke[#smoke+1] = {
		x = x,
		y = y,
		frame = 1,
		time = 0,
		scale = scale,
		momx = N_RandomRange(-2, 2),
		momy = N_RandomRange(-2, -8),
	}
end

local function smokeHandler(v)
	local k = #smoke
	for i = 1, k
		local s = smoke[k]
		if v.patchExists("MEGISM"..s.frame)
			v.drawScaled(s.x*FRACUNIT, s.y*FRACUNIT, s.scale, v.cachePatch("MEGISM"..s.frame))
		end
		s.x = $+s.momx
		s.y = $+s.momy
		s.time = $+1
		if not (s.time%2)
			s.frame = $+1
		end
		k = $-1
		if s.frame > 4
			table.remove(smoke, k)
		end
	end
end

local function megido_hud(v, p, c, t)
	if t > 320 return end
	
	local phyper = p.mo.MP_effects[ef_hyper]
	local psuper = p.powers[pw_super]
	
	local ct = TICRATE*3/2 - t
	
	for k, i in ipairs(cutinframetime)
		local checkframe = cutinStart + i
		local checkframe2 = cutinStart + (cutinframetime[k+1] or TICRATE*3/2)
		if ct <= checkframe
		and ct >= checkframe2
			drawScreenwidePatch(v, v.cachePatch("CUTIN"..k))
			if (k >= 3 and k <= 5)
				drawScreenwidePatch(v, v.cachePatch("ALT_A"..(k-2)))
			end
		end
	end	
	-- optimization does not exist.
	if t > 35
		local bg_flag = max(0, V_90TRANS - (V_10TRANS * ((t-35)/2)))
		drawScreenwidePatch(v, v.cachePatch("MEGIDO5"), bg_flag)
	else
		for i = 1, 16
			stars[i].cframe = 0
		end
	end
	if t > 60 and t < 180
		for i = 1, 16
			if t > 60 + i*2
				if v.patchExists("MEGIS"..stars[i].cframe)
					v.draw(stars[i].x, stars[i].y, v.cachePatch("MEGIS"..stars[i].cframe), nil, v.getColormap(TC_DEFAULT, SKINCOLOR_WHITE))
				end
				if not (leveltime%2)
					stars[i].cframe = min(stars[i].maxframe, $+1)
				end
			end
		end
	end
	if t > 110 and t < 180
		local pp = (t-110)/2
		if v.patchExists("MSPARK"..pp)
			v.draw(190, 70, v.cachePatch("MSPARK"..pp))
		end
	end
	if t > 135 and t < 180
		local x, y = 190, 70
		for i = 1, min(128, (t-135)*16)
			v.drawScaled(x*FRACUNIT, y*FRACUNIT, (FRACUNIT/32 + (i*FRACUNIT/64)) + N_RandomRange(FRACUNIT/64, 0), v.cachePatch("THOKA0"), nil, v.getColormap(TC_DEFAULT, SKINCOLOR_WHITE))
			x = $-2
			y = $+2
		end
	end
	if t == 180
		drawScreenwidePatch(v, v.cachePatch("MEGIDO4"))
	elseif t > 180
		local rnd = {N_RandomRange(-4, 4), N_RandomRange(-4, 4)}
		-- draw the boom
		local x, y = 60 + rnd[1], 140 + rnd[2]
		v.drawScaled(x*FRACUNIT, y*FRACUNIT, FRACUNIT/4 + (t-180)*(FRACUNIT/15), v.cachePatch("MEGIB"..((leveltime/2)%16)+1))
		drawScreenwidePatch(v, v.cachePatch("MEGIGROU"), nil, nil, rnd[1], (t-180)/2 + rnd[2])
		spawnSmoke(x + N_RandomRange(-40 - ((t-180)), 40 + ((t-180))), y+20+((t-180)/4), FRACUNIT + (t-180)*(FRACUNIT/16))
		smokeHandler(v)
	end
	
	if t > 250
		local e = t-250
		local patch = t <= 1 and "MEGIDO1" or t <= 3 and "MEGIDO2" or t <= 5 and "MEGIDO3" or "MEGIDO4"
		if v.patchExists(patch)
			drawScreenwidePatch(v, v.cachePatch(patch))
		end	
		
		if phyper
			v.drawScaled(160*FRACUNIT, 100*FRACUNIT, FRACUNIT, v.cachePatch("MEGIBLCK"))
		else
			
			local f = (t - 250)/2
			
			if psuper
				f = min(4, $)
			end	
			
			if f < 10
				v.drawScaled(160*FRACUNIT, 100*FRACUNIT, FRACUNIT/2, v.cachePatch("H_MEGHP"..f))
			end
			
			local xpos = 140
			local ypos = 65
			
			for i = 1, (psuper and 3 or 4) do
				
				v.drawScaled( (xpos + N_RandomRange(-2, 2))*FRACUNIT, (ypos + N_RandomRange(-2, 2))*FRACUNIT, FRACUNIT/2, v.cachePatch("CIRNOLOL"))
				
				xpos = $ + 9
				ypos = $ - 2
			end
		end
	end
end

local megidodingdong = {
	func = megido_think,
	hudfunc = megido_hud,
}
effectList[ef_megidolaon] = megidodingdong

function A_Megidolaon(actor)
	if not actor.target or not actor.target.player return end
	for p in players.iterate
		if p.mo and p.mo.valid and p.mo.health and p ~= actor.target.player
			MP_giveEffect(p, ef_megidolaon, actor.target)
		end
	end
end

MP_buildMonitor(MT_MEGIDOLAONMONITOR, MT_MEGIDOLAONICON, S_MEGIDOLAONTV, S_MEGIDOLAONPOP1, SPR_MEGI, SPR_MEGI, A_Megidolaon)