function A_Explosion(actor)
	local p = actor.target.player
	if not p.mo.MP_effects[ef_welshdragon]
		MP_giveEffect(p, ef_welshdragon)
	end
end

local function DragLightning(mo, arg)	-- Snu, my beloved, it's in times like these you should use functions;
	S_StartSound(nil, _G["sfx_litng"..P_RandomRange(1, 4)])
	S_StartSound(nil, sfx_rumble)
	P_StartQuake(10*FRACUNIT, 45)
	MP_spawnLightning(mo, arg and SKINCOLOR_RED or SKINCOLOR_EMERALD, arg and SKINCOLOR_EMERALD or SKINCOLOR_RED)
	for p in players.iterate
		P_FlashPal(p, 1, 5)
	end
end
local call = true
local function efct_welsh(mo, inflictor, time)
	if time >= 95 and not mo.welshboosted
		local hyperspark = MP_spawnParticles(mo, MT_HYPERPARTICLE, mo.x+P_RandomRange(30, -30)*mo.scale, mo.y+P_RandomRange(30, -30)*mo.scale, mo.z)
		if hyperspark -- make sure it actually spawned under conditions...
			P_SetObjectMomZ(hyperspark, 5*hyperspark.scale)
			hyperspark.scalespeed = hyperspark.scale/18
			hyperspark.destscale = 1
			hyperspark.glowcolour = P_RandomRange(1, 4)
			hyperspark.scale = mo.scale/2
			local g = hyperspark.glowcolour
			hyperspark.color = (g == 1 and SKINCOLOR_EMERALD) or (g == 2 and SKINCOLOR_RED) or (g == 3 and SKINCOLOR_CRIMSON) or (g == 4 and SKINCOLOR_GREEN)
		end

		local superspark = MP_spawnParticles(mo, MT_SUPERPARTICLE, mo.x+P_RandomRange(15, -15)*mo.scale, mo.y+P_RandomRange(15, -15)*mo.scale, mo.z)
		if superspark -- make sure it actually spawned under conditions...
			P_SetObjectMomZ(superspark, 5*superspark.scale)
			superspark.destscale = 1
			superspark.scalespeed = superspark.scale/18
			superspark.glowcolour = P_RandomRange(1, 4)
			local g = superspark.glowcolour
			superspark.color = (g == 1 and SKINCOLOR_EMERALD) or (g == 2 and SKINCOLOR_RED) or (g == 3 and SKINCOLOR_CRIMSON) or (g == 4 and SKINCOLOR_GREEN)
		end
	end

	if not mo.welshboosted
		local cond = not ((time-95)%30)
		if time == 1
			P_StartQuake(10*FRACUNIT, 95)
		elseif time == 95
			DragLightning(mo)
			S_StartSound(mo, sfx_boost)
			P_SwitchWeather(PRECIP_STORM_NORAIN, nil)
			P_SetupLevelSky(420, nil)
		elseif time >= 155 and time <= 458 and (cond or time == 458)	-- go figure why it's 458 even I don't know.
			DragLightning(mo, call)
			call = not call
		elseif time == 505
			S_StartSound(nil, sfx_sexi)
			mo.welshboosted = true
		end
	else
		local welshcolours = {SKINCOLOR_GREEN, SKINCOLOR_EMERALD, SKINCOLOR_MINT, SKINCOLOR_WHITE, SKINCOLOR_TAN, SKINCOLOR_RED, SKINCOLOR_CRIMSON, SKINCOLOR_RED, SKINCOLOR_TAN, SKINCOLOR_WHITE, SKINCOLOR_MINT, SKINCOLOR_EMERALD}
		local colour = welshcolours[((leveltime /2) or 1)%(#welshcolours)+1]
		mo.color = colour or $
		local ghost = P_SpawnGhostMobj(mo)
		ghost.fuse = 6

		local hyperspark = MP_spawnParticles(mo, MT_HYPERPARTICLE, mo.x+P_RandomRange(30, -30)*mo.scale, mo.y+P_RandomRange(30, -30)*mo.scale, mo.z)
		if hyperspark -- make sure it actually spawned under conditions...
			P_SetObjectMomZ(hyperspark, 20*hyperspark.scale)
			hyperspark.scalespeed = hyperspark.scale/18
			hyperspark.destscale = 1
			hyperspark.glowcolour = P_RandomRange(1, 4)
			local g = hyperspark.glowcolour
			hyperspark.color = (g == 1 and SKINCOLOR_EMERALD) or (g == 2 and SKINCOLOR_RED) or (g == 3 and SKINCOLOR_CRIMSON) or (g == 4 and SKINCOLOR_GREEN)
		end

		local superspark = MP_spawnParticles(mo, MT_SUPERPARTICLE, mo.x+P_RandomRange(15, -15)*mo.scale, mo.y+P_RandomRange(15, -15)*mo.scale, mo.z)
		if superspark -- make sure it actually spawned under conditions...
			P_SetObjectMomZ(superspark, 20*superspark.scale)
			superspark.destscale = 1
			superspark.scalespeed = superspark.scale/18
			superspark.glowcolour = P_RandomRange(1, 4)
			local g = superspark.glowcolour
			superspark.color = (g == 1 and SKINCOLOR_EMERALD) or (g == 2 and SKINCOLOR_RED) or (g == 3 and SKINCOLOR_CRIMSON) or (g == 4 and SKINCOLOR_GREEN)
		end

		if (mo.player.cmd.buttons & BT_TOSSFLAG)
		and (mo.player.pflags & PF_JUMPED)
		and (mo.player.pflags != PF_ROPEHANG)
		and (mo.player.pflags != PF_MACESPIN)
		and (mo.player.pflags & PF_JUMPED)
		and not mo.exploding
			mo.player.pflags = $ & ~PF_JUMPED
			mo.player.pflags = $ & ~PF_SPINNING
			mo.exploding = 1
			S_StartSound(nil, sfx_explos)
			S_StartSound(nil, sfx_rumble)
			P_StartQuake(30*FRACUNIT, 78)
		end

		if mo.exploding
			mo.exploding = $1 + 1
			if mo.exploding >= 1 and mo.exploding <= 70
				mo.state = S_PLAY_SUPER_TRANS1
			elseif mo.exploding >= 71 and mo.exploding <= 74
				mo.state = S_PLAY_SUPER_TRANS2
			elseif mo.exploding == 75
				local modifier = (mo.player.powers[pw_super]) and FRACUNIT*5 or FRACUNIT*3
				local range = FixedMul(modifier, 1536*FRACUNIT)	-- nuke range, but BIGGER
						
				for i = 1, 256
					local explosion = P_SpawnMobj(mo.x+P_RandomRange(-20, 20)*mo.scale, mo.y+P_RandomRange(-20, 20)*mo.scale, mo.z+P_RandomRange(0, 40)*mo.scale, MT_THOK)
					explosion.scale = mo.scale/2
					explosion.destscale = FRACUNIT
					explosion.tics = 2*TICRATE
					explosion.momx = P_RandomRange(-30, 30)*mo.scale
					explosion.momy = P_RandomRange(-30, 30)*mo.scale
					explosion.momz = P_RandomRange(0, 20)*mo.scale
					explosion.scalespeed = FRACUNIT/18
					explosion.flags = $|(MF_NOCLIPTHING)
					explosion.color = i%2 and SKINCOLOR_EMERALD or SKINCOLOR_RED
				end

				S_StartSound(nil, sfx_sexiki)
				P_StartQuake(28*FRACUNIT, 5)
				for breastdragonemperor in players.iterate
					P_FlashPal(breastdragonemperor, 10, 13)
					if (breastdragonemperor == mo.player) then continue end
					
					if (breastdragonemperor.mo and breastdragonemperor.mo.valid)
					and (breastdragonemperor.mo.health)
					and not breastdragonemperor.spectator
						if R_PointToDist2(mo.x, mo.y, breastdragonemperor.mo.x, breastdragonemperor.mo.y) > range continue end
						
						-- Kill players if you're super
						local fn = mo.player.powers[pw_super] and P_KillMobj or P_DamageMobj
						
						breastdragonemperor.mo.MP_nohurtmsg = true
						
						if breastdragonemperor.mo.MP_effects[ef_hyper]
						and mo.player.powers[pw_super]
							breastdragonemperor.rings = 0
							print(breastdragonemperor.cname.." was hit by "..mo.player.cname.."'s explosion and used all their power to withstand it!")
						else	
							fn(breastdragonemperor.mo, mo, mo)
							
							if mo.player.powers[pw_super]
								print(breastdragonemperor.cname.." was hit by "..mo.player.cname.."'s explosion, and was killed instantly.")
							else
								if MP_isDead(breastdragonemperor)
									print(breastdragonemperor.cname.." was killed by "..mo.player.cname.."'s explosion!")
								else
									print(breastdragonemperor.cname.." was hit by "..mo.player.cname.."'s explosion!")
								end
							end						
							breastdragonemperor.mo.MP_nohurtmsg = false
						end
						
						P_InstaThrust(breastdragonemperor.mo, R_PointToAngle2(mo.x, mo.y, breastdragonemperor.mo.x, breastdragonemperor.mo.y), 5*FRACUNIT)
						P_SetObjectMomZ(breastdragonemperor.mo, 19*FRACUNIT)
						P_SpawnMobj(breastdragonemperor.mo.x, breastdragonemperor.mo.y, breastdragonemperor.mo.z, MT_DRAGONEXPL)
					end
				end
				
				for allhailgrabbindragon in mobjs.iterate()
					if allhailgrabbindragon.flags & (MF_ENEMY|MF_BOSS)
						if R_PointToDist2(mo.x, mo.y, allhailgrabbindragon.x, allhailgrabbindragon.y) > range continue end
						P_KillMobj(allhailgrabbindragon, mo, mo)
					end
				end
			elseif mo.exploding >= 75 and mo.exploding <= 78
				mo.state = S_PLAY_SUPER_TRANS3
			elseif mo.exploding >= 79 and mo.exploding <= 183
				mo.state = S_PLAY_SUPER_TRANS4
			elseif mo.exploding >= 184
				mo.state = S_PLAY_FALL
				MP_loseEffect(mo.player, ef_welshdragon)
			end
		end
	end
end

local dargoncolours = {"\x85", "\x87", "\x82"}

local welsh_data = {
	func = efct_welsh,
	get = function(mo)
					S_StartSound(nil, sfx_over)
					S_StartSound(nil, sfx_rumble)
					for p in players.iterate
						P_PlayJingleMusic(p, "HIGHDX")
						if p ~= mo.player
							COM_BufInsertText(p, "cecho "..mo.player.name.." \\is gaining power!\\\\Hurt them before they destroy\\all of you!!!")
							S_StartSound(nil, sfx_strpst)
						end
					end
				end,
	hit = function(mo) if mo.MP_effects[ef_welshdragon] then MP_loseEffect(mo.player, ef_welshdragon) end end, //Well that's unforunate
	lose = function(mo)
					P_SwitchWeather(mapheaderinfo[gamemap].weather, nil)
					P_SetupLevelSky(mapheaderinfo[gamemap].skynum, nil)
					if mo.exploding
						mo.exploding = nil
						mo.welshboosted = nil
						mo.color = mo.player.skincolor
					else
						if mo.welshboosted //Player was boosted
							S_StartSound(mo, sfx_nodra2)
							mo.welshboosted = nil
							mo.color = mo.player.skincolor
						else
							S_StopSound(mo)
							S_StartSound(mo, sfx_nodrag)
						end
					end
					for p in players.iterate
						P_RestoreMusic(p)
					end
				end,
	hudfunc = function(v,p,c,t)
				if not p.mo return end
				local mo = p.mo
				if mo.welshboosted
					local y = splitscreen and (#p == 0 and 32 or #p == 1 and 132) or 130	-- use ternaries, they're cool.
					local dxdclr = dargoncolours[(leveltime or 1)/2%(#dargoncolours)+1] or "\x82"
					v.drawString(160, y, dxdclr.."JUMP AND PRESS TOSSFLAG", nil, "center")
					v.drawString(160, y+10, dxdclr.."TO RELEASE THE POWER!", nil, "center")
				end
			end,
	hudico = "EXPLICO",
}
effectList[ef_welshdragon] = welsh_data

/*addHook("HurtMsg", function(p, inflictor, source)

	if not inflictor return end
	if not inflictor.valid return end
	if not inflictor.player return end

	if inflictor.MP_effects[ef_welshdragon]
	and inflictor.exploding == 75
		if inflictor.player.powers[pw_super]
			print(p.cname.." was hit by "..inflictor.player.cname.."'s explosion, and was killed instantly.")
			return true
		else
			if MP_isDead(p)
				print(p.cname.." was killed by "..inflictor.player.cname.."'s explosion!")
				return true
			else
				print(p.cname.." was hit by "..inflictor.player.cname.."'s explosion!")
				return true
			end
		end
	end
end)*/

addHook("ShouldJingleContinue", function(p, musname)
	if musname == "HIGHDX"
		for p2 in players.iterate do
			if p2 and p2.mo and p2.mo.valid and p2.mo.MP_effects[ef_welshdragon] return true end
		end
	end
end)

sfxinfo[sfx_boost] = {
        singular = false,
        priority = 64,
        flags = SF_X4AWAYSOUND|SF_X8AWAYSOUND|SF_X2AWAYSOUND
}

mobjinfo[MT_DRAGONEXPL] = {
	doomednum = -1,
	spawnstate = S_DRAGONEXPL1,
	spawnhealth = 1,
	seestate = S_NULL,
	seesound = sfx_None,
	reactiontime = 0,
	attacksound = SFX_None,
	painstate = S_NULL,
	painsound = sfx_None,
	meleestate = S_NULL,
	missilestate = S_NULL,
	deathstate = S_NULL,
	deathsound = sfx_None,
	speed = 0,
	radius = 32*FRACUNIT,
	height = 64*FRACUNIT,
	dispoffset = 2,
	mass = 200,
	damage = MT_NULL,
	activesound = sfx_None,
	flags = MF_NOGRAVITY|MF_NOCLIPTHING,
	raisestate = MT_NULL
}

states[S_DRAGONEXPL1] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|A,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL2
}
states[S_DRAGONEXPL2] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|B,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL3
}
states[S_DRAGONEXPL3] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|C,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL4
}
states[S_DRAGONEXPL4] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|D,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL5
}
states[S_DRAGONEXPL5] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|E,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL6
}
states[S_DRAGONEXPL6] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|F,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL7
}
states[S_DRAGONEXPL7] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|G,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL8
}
states[S_DRAGONEXPL8] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|H,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL9
}
states[S_DRAGONEXPL9] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|I,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL10
}
states[S_DRAGONEXPL10] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|J,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL11
}
states[S_DRAGONEXPL11] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|K,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL12
}
states[S_DRAGONEXPL12] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|L,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL13
}
states[S_DRAGONEXPL13] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|M,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL14
}
states[S_DRAGONEXPL14] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|N,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL15
}
states[S_DRAGONEXPL15] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|O,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL16
}
states[S_DRAGONEXPL16] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|P,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL17
}
states[S_DRAGONEXPL17] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|Q,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL18
}
states[S_DRAGONEXPL18] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|R,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL19
}
states[S_DRAGONEXPL19] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|S,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL20
}
states[S_DRAGONEXPL20] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|T,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_DRAGONEXPL21
}
states[S_DRAGONEXPL21] = {
	sprite = SPR_OXPL,
	frame = FF_FULLBRIGHT|U,
	tics =   1,
	action = None,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

MP_buildMonitor(MT_EXPLOSIONMONITOR, MT_EXPLOSIONICON, S_EXPLOSIONTV, S_EXPLOSIONPOP1, SPR_EXPL, SPR_EXPL, A_Explosion)

states[S_HYPERPART1] = {SPR_SUBP, FF_FULLBRIGHT|A, 2, nil, 0, 0, S_HYPERPART2}
states[S_HYPERPART2] = {SPR_SUBP, FF_FULLBRIGHT|B, 2, nil, 0, 0, S_HYPERPART3}
states[S_HYPERPART3] = {SPR_SUBP, FF_FULLBRIGHT|C, 2, nil, 0, 0, S_HYPERPART4}
states[S_HYPERPART4] = {SPR_SUBP, FF_FULLBRIGHT|D, 2, nil, 0, 0, S_HYPERPART5}
states[S_HYPERPART5] = {SPR_SUBP, FF_FULLBRIGHT|E, 2, nil, 0, 0, S_HYPERPART6}
states[S_HYPERPART6] = {SPR_SUBP, FF_FULLBRIGHT|F, 2, nil, 0, 0, S_HYPERPART7}
states[S_HYPERPART7] = {SPR_SUBP, FF_FULLBRIGHT|G, 6, nil, 0, 0, S_NULL}

mobjinfo[MT_HYPERPARTICLE] = {
	doomednum = -1,
    spawnstate = S_HYPERPART1,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_None,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_NULL,
    painchance = 1,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_None,
    speed = 1*FRACUNIT,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    dispoffset = 1,
    mass = 16,
    damage = 1*FRACUNIT,
    activesound = sfx_None,
    flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT,
    raisestate = MT_THOK
}