function A_Regeneration(actor)
	local p = actor.target.player
	MP_giveEffect(p, ef_regen)
end

local regen_data = {
	time = 400,
	func = function(mo, inflictor, time)
				if not (time%5)
					P_GivePlayerRings(mo.player, 1)
					S_StartSound(mo, sfx_itemup)
				end
				local regenpart = MP_spawnParticles(mo, MT_REGENPARTICLE)
				if regenpart
					regenpart.destscale = 1
					regenpart.fuse = 30
				end
			end,
	get = function(mo) S_StartSound(mo, sfx_regen) end,
	lose = function(mo) S_StartSound(mo, sfx_chchng) end,
	
	hudico = "REICON",

	hudfunc = function(v, p, c, t)
		if not p.mo return end
		local mo = p.mo
		if leveltime % 10 < 5
			v.draw(hudinfo[HUD_RINGS].x, hudinfo[HUD_RINGS].y, v.cachePatch("REG_RING"), V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER)
		end
	end,
}
effectList[ef_regen] = regen_data

MP_buildMonitor(MT_REGENMONITOR, MT_REGENICON, S_REGENTV, S_REGENPOP1, SPR_REGE, SPR_REGE, A_Regeneration)

states[S_REGENPART1] = {SPR_REGP, A, 2, nil, 0, 0, S_REGENPART2}
states[S_REGENPART2] = {SPR_REGP, TR_TRANS30|A, 2, nil, 0, 0, S_REGENPART3}
states[S_REGENPART3] = {SPR_REGP, TR_TRANS60|A, 2, nil, 0, 0, S_REGENPART4}
states[S_REGENPART4] = {SPR_REGP, TR_TRANS90|A, 2, nil, 0, 0, S_NULL}

mobjinfo[MT_REGENPARTICLE] = {
	doomednum = -1,
    spawnstate = S_REGENPART1,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_None,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_NULL,
    painchance = 1,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_None,
    speed = 1*FRACUNIT,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    dispoffset = 1,
    mass = 16,
    damage = 1*FRACUNIT,
    activesound = sfx_None,
    flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT,
    raisestate = MT_THOK
}