-- touch. my sentry

function A_ReadySentry(actor)
	if not actor.target or not actor.target.player
		print("ERROR: A_ReadySentry: Power up has no target.")
		return
	end
	
	local p = actor.target.player
	MP_giveEffect(p, ef_sentry)
end

addHook("ShouldDamage", function(mo, inflictor)
	
	if not mo.player return end
	
	if inflictor and inflictor.valid and (inflictor.type == MT_SENTRY and inflictor.placeby == mo.player or source and source.type == MT_SENTRY and (source.placeby == mo.player or source.placeby.ctfteam == mo.player.ctfteam and G_GametypeHasTeams()))
		return false
	end
end, MT_PLAYER)

addHook("MobjDamage", function(mo)
	
	S_StartSound(mo, sfx_dmpain)
	mo.inv = TICRATE

end, MT_SENTRY)

addHook("MobjDeath", function(mo, inflictor, source)
	
	local p
	if inflictor and inflictor.player
		p = inflictor.player
	elseif source and source.player
		p = source.player	
	end
	
	if p
		P_AddPlayerScore(p, 100)
	end	
	mo.state = S_XPLD1
	S_StartSound(mo, sfx_pop)
	return true
end, MT_SENTRY)

addHook("MobjDamage", function(mo, inflictor)
	local num = 50
	if mo and mo.valid and not mo.health and not (mo.player and SH_HasShield(mo.player)) then num = 100 end

	if inflictor and inflictor.valid and inflictor.nohit and inflictor.nohit.valid and inflictor.nohit.placeby and inflictor.nohit.placeby.valid
		inflictor.nohit.placeby.score = $+num
	end
end, MT_PLAYER)

addHook("ShouldDamage", function(mo, inflictor, source)
	
	if not mo.placeby return end
	if mo.inv then return false end

	if G_GametypeHasTeams() and inflictor and inflictor.valid and inflictor.type == MT_PLAYER and inflictor.player and inflictor.player.ctfteam == mo.placeby.ctfteam then return false end
	if G_GametypeHasTeams() and source and source.type == MT_PLAYER and source.player.ctfteam == mo.placeby.ctfteam then return false end
	if inflictor and inflictor.valid and inflictor.nohit == mo then return false end
	if inflictor and inflictor.valid and (inflictor.type == MT_PLAYER and inflictor.player and inflictor.player == mo.placeby or source and source.type == MT_PLAYER and source.player and source.player == mo.placeby)
		return false
	end
end, MT_SENTRY)

addHook("MobjCollide", function(mo, touch)

	if mo and mo.valid and mo.player and touch and touch.valid and touch.placey and touch.placeby == mo.player
	
		return false
	end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(mo, touch)	-- PARANOIA

	if mo and mo.valid and mo.player and touch and touch.valid and touch.placey and touch.placeby == mo.player
		return false
	end
end, MT_PLAYER)

local sentry_dta = {
	
	ico = "SNTYICO",
	
	get = function(mo)
		local p = mo.player
		
		if not p.sentries
			p.sentries = {}
		end
		mo.sentryready = 1
		S_StartSound(nil, sfx_sentry, p)	
	end,
	
	func = function(mo)
		local p = mo.player

		if not mo.sentryready return end
		
		if mo.sentryready
			mo.sentryready = $+1
		end

		p.weapondelay = 5
		if P_IsObjectOnGround(mo)
		and p.cmd.buttons & BT_ATTACK
		and not (p.pflags & PF_SPINNING)
		and p.mo.sentryready > 5
			
			local sentry = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SENTRY)
			sentry.state = S_THOK
			sentry.sprite = SPR_TRET
			sentry.frame = A
			sentry.tics = -1
			sentry.placeby = p
			sentry.health = 5
			sentry.bullets = 250
			sentry.angle = mo.angle
			S_StartSound(mo, sfx_psntry)
			table.insert(p.sentries, sentry)
			if #p.sentries > 2
				if p.sentries[1] and p.sentries[1].valid
					P_KillMobj(p.sentries[1])
				end
				table.remove(p.sentries, 1)
			end
			mo.sentryready = nil
			
			MP_loseEffect(p, ef_sentry)
			
		end	
	end,
}

effectList[ef_sentry] = sentry_dta

addHook("ThinkFrame", do
	for p in players.iterate
		if p.sentries and #p.sentries
			for k,v in ipairs(p.sentries)
				if not v and v.valid
				or (v and v.valid and not v.health)
					table.remove(p.sentries, k)
				end
			end
		end	
	end
end)

-- sentry thinker

local function sentryLookForPlayers(mo)
	mo.target = nil
	for p in players.iterate
		if mo.target continue end
		if not p.mo continue end
		if p == mo.placeby continue end
		if not p.mo.MP_effects return end	--!??!???
		if p.mo.MP_effects[ef_invisible] continue end
		if p.mo and p.mo.health and R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y) < 1512*mo.scale
		and P_CheckSight(mo, p.mo)
			mo.target = p.mo
		end
	end
	return mo.target
end

addHook("MobjThinker", function(mo)
	
	if mo and mo.valid
	and mo.health
		
		mo.state = S_THOK
		mo.sprite = SPR_TRET
		mo.frame = A	
		mo.tics = -1
		
		if mo.inv
			mo.inv = $-1
			if not (leveltime % 2)
				mo.flags2 = $|MF2_DONTDRAW
			else
				mo.flags2 = $ & ~MF2_DONTDRAW
			end

			mo.target = nil
			mo.chargeshot = nil
			return
		else
			mo.flags2 = $ & ~MF2_DONTDRAW
			mo.flags2 = $ & ~MF2_FRET
		end
				

		if mo.placeby and mo.placeby.valid and not (mo.placeby and mo.placeby.valid and mo.placeby.spectator)
		else
			P_KillMobj(mo)
			return
		end

		if not mo.bullets
			P_KillMobj(mo)
			return
		end

		if not mo.saveangle
			mo.saveangle = mo.angle
		end	
		
		if not mo.target
		or mo.target and ((mo.target.eflags & MFE_UNDERWATER and not (mo.eflags & MFE_UNDERWATER)) or (mo.eflags & MFE_UNDERWATER and not (mo.target.eflags & MFE_UNDERWATER)))
			mo.chargeshot = 0
			//P_LookForPlayers(mo, 1024*FRACUNIT, true)
			//if not mo.target
			sentryLookForPlayers(mo)
			//end
			mo.angle = mo.saveangle
			if G_GametypeHasTeams() and mo.target and mo.target.player and mo.target.player == mo.placeby then mo.target = nil end
			if G_GametypeHasTeams() and mo.target and mo.placeby and mo.placeby.valid and mo.target.player.ctfteam == mo.placeby.ctfteam then mo.target = nil end
			if mo.target == mo.placeby.mo then mo.target = nil return end
		else
			
			if not mo.chargeshot
				mo.chargeshot = 1
				S_StartSound(mo, sfx_s3k84)
			end
			
			mo.chargeshot = $+1
			A_FaceTarget(mo)
			
			if mo.chargeshot >= TICRATE
				if mo.target and mo.target.health
					S_StartSound(mo, sfx_trfire)
				
					local aimtarget = P_SpawnMobj(mo.target.x, mo.target.y, mo.target.z, MT_THOK)
					aimtarget.state = S_INVISIBLE
					aimtarget.tics = 1
					local fg = P_SpawnMobj(mo.x, mo.y, mo.z+mo.height/2, MT_TURRETLASER)
					fg.frame = A
					fg.target = mo
					fg.nohit = mo
					fg.tracer = aimtarget
					fg.flags = MF_MISSILE|MF_NOGRAVITY
					A_HomingChase(fg, 128*FRACUNIT, 1)
					mo.bullets = $-1
					//mo.chargeshot = nil
					//mo.target = nil
				else
					mo.chargeshot = nil
					mo.target = nil
				end
			end
			
			if mo.target
			and R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y) > 1200*FRACUNIT
			//or not P_CheckSight(mo, mo.target)
				mo.target = nil
			end
		end	
		
	end	

end, MT_SENTRY)

hud.add(function(v, p)

if not p.mo return end
local mo = p.mo
	
	if not p.sentries return end
	local basex = 16
	local basey = 70 + 24*#p.sentries
	
	if mo.sentryready
	and leveltime%10 < 5
		v.drawString(basex, basey, "FIRE: BUILD SENTRY", V_YELLOWMAP|V_SNAPTOTOP|V_SNAPTOLEFT, "thin")
	end
	
	//if not (p.sentries[1] and p.sentries[1].valid) return end

	for k,s in ipairs(p.sentries)
		if not s continue end
		if not s.valid continue end
		basex = 38
		basey = 85+ 24*(k-1)
		
		if not (s.inv and s.inv%2)
			v.drawScaled(basex*FRACUNIT, basey*FRACUNIT, FRACUNIT/2, v.cachePatch("TRETA2A8"), V_SNAPTOTOP|V_SNAPTOLEFT)
		end
		if s and s.valid
			basex = 60
			basey = 70 + 24*(k-1)

			v.drawString(basex, basey, "HP: "..s.health.." I 5 \nAMMO: "..s.bullets.." I 250", V_SNAPTOTOP|V_SNAPTOLEFT, "thin")
		end
	end
end)

MP_buildMonitor(MT_SENTRYMONITOR, MT_SENTRYICON, S_SENTRYTV, S_SENTRYPOP1, SPR_SENT, SPR_SENT, A_ReadySentry)

states[S_SENTRY] = {SPR_TRET, A, -1, nil, 0, 0, S_SENTRY}

mobjinfo[MT_SENTRY] = {
	doomednum = -1,
    spawnstate = S_SENTRY,
    spawnhealth = 5,
    reactiontime = 8,
    deathstate = S_XPLD1,
    deathsound = sfx_pop,
	painstate = S_SENTRY,
	painsound = sfx_dmpain,
    radius = 16*FRACUNIT,
    height = 48*FRACUNIT,
    flags = MF_SHOOTABLE|MF_ENEMY|MF_SPECIAL,
}