function A_BlueFire(actor)
	if actor and actor.valid
		actor.frame = leveltime%4 | FF_TRANS50
		actor.frame = leveltime%4 | FF_FULLBRIGHT
	end
end

states[S_BLUEFIRE] = {SPR_BFLM, A, 1, A_BlueFire, 0, 0, S_BLUEFIRE}

function A_Turbo(actor)
    if not (actor.target and actor.target.player) return end
    local p = actor.target.player
	MP_giveEffect(p, ef_turbo)
end

addHook("ShouldDamage", function(mo, inflictor)

	if mo and mo.player and mo.MP_effects and mo.MP_effects[ef_turbo]
	and inflictor and inflictor.valid and inflictor.flags & MF_ENEMY
		P_DamageMobj(inflictor, mo, mo)
		return false
	end
end, MT_PLAYER)

addHook("ShouldDamage", function(mo, inflictor)

	if not inflictor or not inflictor.valid return end
	if not inflictor.target or not inflictor.target.valid return end
	if inflictor.type == MT_FLAME

		if friendPlayer(inflictor.target.player, mo.player)
		or mo.player and P_PlayerInPain(mo.player)
			return false
		end
	end
end, MT_PLAYER)

addHook("MobjDamage", function(mo, inflictor, source)

	if mo and mo.valid and inflictor and inflictor.target and inflictor.target.player and inflictor.type == MT_FLAME	-- 02/09/18 FUCK OFF
	and not friendPlayer(inflictor.target.player, mo.player)
		
		if not mo.player.powers[pw_shield]
		and mo.health == 1
			P_AddPlayerScore(inflictor.target.player, 100)
		else
			P_AddPlayerScore(inflictor.target.player, 50)
		end
	end
end, MT_PLAYER)

local function gofast(mo, inflictor, t)

	local p = mo.player

	if not P_PlayerInPain(p)
		P_InstaThrust(mo, mo.angle, 60*FRACUNIT)
		if P_IsObjectOnGround(mo) and not (mo.eflags & MFE_UNDERWATER or mo.eflags & MFE_TOUCHWATER)
			local fire = P_SpawnMobj(mo.x, mo.y, mo.z, MT_FLAME)
			fire.flags = MF_MISSILE|MF_GRENADEBOUNCE
			fire.state = S_BLUEFIRE
			fire.fuse = TICRATE*6
			fire.target = mo
			fire.scale = mo.scale
			fire.destscale = 1
			fire.scalespeed = mo.scale/200
			S_StartSound(mo, sfx_s3k48)
		end
	end
	p.charflags = $1|SF_RUNONWATER
	local ghost = P_SpawnGhostMobj(mo)
	ghost.fuse = 4
end

local mk_data = {
	time = 620,
	func = gofast,
	hudico = "TURBOICO",
	get = function(mo)
				local p = mo.player
				S_StartSound(mo, sfx_turbo)
				if not p.powers[pw_super]
					P_PlayJingleMusic(p, "turbo")
				end	
			end,
	lose = function(mo)
				local p = mo.player
				p.charflags = $1 & ~SF_RUNONWATER
				P_RestoreMusic(mo.player)
			end,
}
effectList[ef_turbo] = mk_data

MP_buildMonitor(MT_TURBOMONITOR, MT_TURBOICON, S_TURBOTV, S_TURBOPOP1, SPR_TURB, SPR_TURB, A_Turbo)