local function uncrumble()

	S_StartSound(nil, sfx_crum)
	if not server.savecrumbl return end
	for sector in sectors.iterate do

		if not sector.ffloors() continue end

		local i= 0
		for rover in sector.ffloors() do

			i = $+1
			if not server.savecrumbl[#sector][i] continue end

			rover.flags = server.savecrumbl[#sector][i].flags
		end
	end
	server.savecrumbl = nil
end

local crumble_dta = {
	timer = TICRATE*15,
	icon = "CRUMBICO",
	stop = uncrumble,
	dontdo = function()
				if MP_geffect_active(gef_pancake) or MP_geffect_active(gef_expand)
					S_StartSound(nil, sfx_lose)
					return true
				end
			end,
	start = function()
				S_StartSound(nil, sfx_crum)
				server.savecrumbl = {}

				-- do it once to save

				for sector in sectors.iterate do
					if not sector.ffloors() continue end

					server.savecrumbl[#sector] = {}
					local i= 0

					for rover in sector.ffloors() do

						i = $+1
						if rover and rover.valid and rover.flags & FF_SOLID and not (rover.flags & FF_SWIMMABLE) then

							server.savecrumbl[#sector][i] = {
								flags = rover.flags,
								toppos = rover.topheight,
								botpos = rover.bottomheight,
							}
						end
					end
				end

				-- another time to apply

				for sector in sectors.iterate do
					for crumble in sector.ffloors() do
						if crumble and crumble.valid and crumble.flags & FF_SOLID
							if not (crumble.flags & FF_SWIMMABLE)
								crumble.flags = $|FF_CRUMBLE
							end
						end
					end
				end
			end,
}
geffectList[gef_crumble] = crumble_dta

function A_Fof(actor)
	MP_addGlobalEffect(gef_crumble)
end

MP_buildMonitor(MT_FOFMONITOR, MT_FOFICON, S_FOFTV, S_FOFPOP1, SPR_FOFM, SPR_FOFM, A_Fof)