local function ungoop()

	S_StartSound(nil, sfx_goop)
	if not server.savegoo return end
	for sector in sectors.iterate do

		if not sector.ffloors() continue end

		local i= 0
		for rover in sector.ffloors() do

			i = $+1
			if not server.savegoo[#sector][i] continue end

			rover.flags = server.savegoo[#sector][i].flags
			rover.toppic = server.savegoo[#sector][i].ceilingtexture
			rover.bottompic = server.savegoo[#sector][i].floortexture
			rover.sector.ceilingpic = server.savegoo[#sector][i].ceilingtexture
			rover.sector.floorpic = server.savegoo[#sector][i].floortexture
			if server.savegoo[#sector][i].siden
				rover.master.backside.midtexture = server.savegoo[#sector][i].walltexture
			else
				rover.master.frontside.midtexture = server.savegoo[#sector][i].walltexture
			end
		end
	end
	server.savegoo = nil
end

local goop_dta = {
	icon = "GOOPICO",
	timer = TICRATE*15,
	stop = ungoop,
	start = 	function()
					S_StartSound(nil, sfx_goop)
					server.savegoo = {}
					-- do it once to save

					for sector in sectors.iterate do
						if not sector.ffloors() continue end
						server.savegoo[#sector] = {}
						local i= 0
						for rover in sector.ffloors() do
							i = $+1
							if rover and rover.valid and rover.flags & FF_SWIMMABLE and not (rover.flags & FF_GOOWATER) then
								local siden = 1
								local texture
								local ftexture = rover.sector.floorpic
								local ctexture = rover.sector.ceilingpic

								if rover.master.frontside
									siden = 0
									texture = rover.master.frontside.midtexture
								else
									siden = 1
									texture = rover.master.backside.midtexture
								end
								server.savegoo[#sector][i] = {
								flags = rover.flags,
								floortexture = ftexture,
								ceilingtexture = ctexture,
								walltexture = texture,
								side_n = siden
								}
							end
						end
					end

					-- do it again to apply

					for sector in sectors.iterate do
						if not sector.ffloors() continue end
						for rover in sector.ffloors() do
							if rover and rover.valid and rover.flags & FF_SWIMMABLE and not (rover.flags & FF_GOOWATER) then
								rover.flags = $ & ~FF_SOLID
								rover.flags = $|FF_GOOWATER|FF_SWIMMABLE
								rover.toppic = "VIOFLR"
								rover.bottompic = "VIOFLR"
								if siden
									rover.master.backside.midtexture = R_TextureNumForName("2FALL1")
								else
									rover.master.frontside.midtexture = R_TextureNumForName("2FALL1")
								end
							end
						end
					end
				end,

}
geffectList[gef_goop] = goop_dta


function A_Goop(actor)
	MP_addGlobalEffect(gef_goop)
end

MP_buildMonitor(MT_GOOPMONITOR, MT_GOOPICON, S_GOOPTV, S_GOOPPOP1, SPR_GPMT, SPR_GPMT, A_Goop)