function A_BumperShield(actor)
	if not actor.target or not actor.target.player
		print("ERROR: A_BumperShield: Power up has no target.")
		return
	end

	local p = actor.target.player
	MP_giveShield(p, SH_BUMPERSHIELD)
end

local function BumperBlast(mo)
	P_NukeEnemies(mo, mo, 0*FRACUNIT)
	S_StartSound(mo, sfx_s3kaa)
	
	local bump = P_SpawnMobj(mo.x+P_RandomRange(-30, 30)*FRACUNIT, mo.y+P_RandomRange(-30, 30)*FRACUNIT, mo.z+P_RandomRange(0, 60)*FRACUNIT, MT_SPARK)
	bump.flags = MF_NOGRAVITY
	bump.momz = -3*FRACUNIT
	bump.destscale = 1
	bump.fuse = 20
end

local function bump_special(mo)
	local p = mo.player
	
	p.pflags = $|(PF_THOKKED|PF_SHIELDABILITY)
	mo.momz = -(mo.momz)
	BumperBlast(mo)
	return true
end

local function setBumpInfo(mo)
	mo.flags = $|MF_BOUNCE
	mo.activesound = sfx_s3kaa
end

local function unsetBumpInfo(mo)
	mo.flags = $ & ~MF_BOUNCE
	mo.activesound = mobjinfo[MT_PLAYER].activesound
end

local bumpshield_data = {
	orbstate = S_BUMP_ORB1,
	hudico = "BUMPICO",
	sound = sfx_s3kaa,
	get = setBumpInfo,
	special = bump_special,
	hit = unsetBumpInfo,
	change = unsetBumpInfo,
}
shieldList[SH_BUMPERSHIELD] = bumpshield_data

MP_buildMonitor(MT_BUMPERMONITOR, MT_BUMPERICON, S_BUMPERTV, S_BUMPERPOP1, SPR_BPTV, SPR_BPTV, A_BumperShield)

states[S_BUMP_ORB1] = {SPR_BUMP, A|TR_TRANS50, 2, nil, 0, 0, S_BUMP_ORB2}
states[S_BUMP_ORB2] = {SPR_BUMP, B|TR_TRANS50, 2, nil, 0, 0, S_BUMP_ORB3}
states[S_BUMP_ORB3] = {SPR_BUMP, C|TR_TRANS50, 2, nil, 0, 0, S_BUMP_ORB4}
states[S_BUMP_ORB4] = {SPR_BUMP, D|TR_TRANS50, 2, nil, 0, 0, S_BUMP_ORB5}
states[S_BUMP_ORB5] = {SPR_BUMP, E|TR_TRANS50, 2, nil, 0, 0, S_BUMP_ORB6}
states[S_BUMP_ORB6] = {SPR_BUMP, F|TR_TRANS50, 2, nil, 0, 0, S_BUMP_ORB7}
states[S_BUMP_ORB7] = {SPR_BUMP, G|TR_TRANS50, 2, nil, 0, 0, S_BUMP_ORB8}
states[S_BUMP_ORB8] = {SPR_BUMP, H|TR_TRANS50, 2, nil, 0, 0, S_BUMP_ORB1}

mobjinfo[MT_PLAYER].activesound = sfx_s3kaa