local explosiontimer = 0

function A_AntimatterShield(actor, var1, var2)
	if not (actor and actor.target and actor.target.player) return end
	local receiver = actor.target

	MP_giveShield(receiver.player, SH_KINETICSHIELD)
end

-- alt ability test

local function antiInit(mo)
	mo.anti_save = nil
	S_StartSound(mo, sfx_s3k73)
end

local function antiThink(mo)
	local p = mo.player
	local player = p

	if p.pflags & PF_STARTDASH
	or (p.pflags & PF_SPINNING and (P_IsObjectOnGround(mo)))
		mo.spin_prev = true
	else
		if not (p.cmd.buttons & BT_USE)
		or not ((p.cmd.buttons & BT_USE) and p.pflags & PF_SPINNING and not P_IsObjectOnGround(mo))
			mo.spin_prev = false
		end
	end

	if MP_climbButtonCheck(p)
		mo.climbhack = true
	end
	mo.climbhack = $ and p.cmd.buttons & BT_USE
	
	if mo.climbhack return end

	if mo.anti_save
		local hyperspark = MP_spawnParticles(mo, MT_ANTIPARTICLE, mo.x+P_RandomRange(40, -40)*mo.scale, mo.y+P_RandomRange(40, -40)*mo.scale)
		if hyperspark -- make sure it actually spawned under conditions...
			hyperspark.momz = 0
			hyperspark.scalespeed = hyperspark.scale/18
			hyperspark.destscale = 1
		end
	end
	
	-- just so we can store energy outside of the shield special
	if not P_IsObjectOnGround(mo)
	and not mo.spin_prev
	and p.cmd.buttons & BT_USE
	and not mo.used_anti
	and not (p.pflags & PF_THOKKED)
	and not mo.anti_save
		mo.anti_save = {p.speed, mo.momz}
		S_StartSound(mo, sfx_s3k9c)
	end
end

local function antiSpecial(mo)
	local p = mo.player
	
	if (mo.anti_save)
		P_InstaThrust(mo, mo.angle, mo.anti_save[1])
		mo.momz = mo.anti_save[2]
		mo.anti_save = nil
		mo.state = ((mo.momz * P_MobjFlip(mo)) > 0) and S_PLAY_SPRING or S_PLAY_FALL
		p.pflags = $ & ~(PF_JUMPED)
		S_StartSound(mo, sfx_kineti)
		for i = 1, 32
			local spark = P_SpawnMobj(mo.x, mo.y, mo.z, MT_ANTIPARTICLE)
			spark.momx = P_RandomRange(-20, 20)*mo.scale
			spark.momy = P_RandomRange(-20, 20)*mo.scale
			spark.momz = P_RandomRange(-20, 20)*mo.scale
			spark.scale = mo.scale
			spark.destscale = 1
			spark.scalespeed = mo.scale/12
		end
		
		p.pflags = $|(PF_THOKKED|PF_SHIELDABILITY)
	else
		mo.anti_save = {p.speed, mo.momz}
		S_StartSound(mo, sfx_s3k9c)
	end
	
	return true
end

local anti_data = {
	orbstate = S_ANTISHIELD1,
	hudico = "ANICON",
	get = antiInit,
	func = antiThink,	-- don't think, lose braincells
	special = antiSpecial,
	--hit = antiHit,
}
shieldList[SH_KINETICSHIELD] = anti_data

MP_buildMonitor(MT_ANTIMATTERMONITOR, MT_ANTIMATTERICON, S_ANTITV, S_ANTIPOP1, SPR_ANTV, SPR_ANTV, A_AntimatterShield)

mobjinfo[MT_ANTISHIELD] = {
	doomednum = -1,
    spawnstate = S_ANTISHIELD1,
    spawnhealth = 1000,
    seestate = S_NULL,
    seesound = sfx_shield,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_NULL,
    painchance = 1,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_None,
    speed = 2*FRACUNIT,
    radius = 32*FRACUNIT,
    height = 64*FRACUNIT,
    dispoffset = 1,
    mass = 16,
    damage = 62*FRACUNIT,
    activesound = sfx_None,
    flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY,
    raisestate = MT_THOK
}

mobjinfo[MT_ANTIPARTICLE] = {
	doomednum = -1,
    spawnstate = S_ANTIPART1,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_None,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_NULL,
    painchance = 1,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_None,
    speed = 1*FRACUNIT,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    dispoffset = 1,
    mass = 16,
    damage = 1*FRACUNIT,
    activesound = sfx_None,
    flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT,
    raisestate = MT_THOK
}

states[S_ANTIPART1] = {SPR_ANTP, TR_TRANS30|A, 2, nil, 0, 0, S_ANTIPART2}
states[S_ANTIPART2] = {SPR_ANTP, TR_TRANS30|B, 2, nil, 0, 0, S_ANTIPART3}
states[S_ANTIPART3] = {SPR_ANTP, TR_TRANS30|C, 2, nil, 0, 0, S_ANTIPART4}
states[S_ANTIPART4] = {SPR_ANTP, TR_TRANS30|D, 2, nil, 0, 0, S_ANTIPART5}
states[S_ANTIPART5] = {SPR_ANTP, TR_TRANS30|E, 2, nil, 0, 0, S_ANTIPART6}
states[S_ANTIPART6] = {SPR_ANTP, TR_TRANS30|F, 2, nil, 0, 0, S_ANTIPART7}
states[S_ANTIPART7] = {SPR_ANTP, TR_TRANS30|G, 6, nil, 0, 0, S_NULL}

states[S_ANTISHIELD1] = {SPR_ANTI, TR_TRANS30|A, 1, nil, 0, 0, S_ANTISHIELD2}
states[S_ANTISHIELD2] = {SPR_ANTI, TR_TRANS30|B, 1, nil, 0, 0, S_ANTISHIELD3}
states[S_ANTISHIELD3] = {SPR_ANTI, TR_TRANS30|C, 1, nil, 0, 0, S_ANTISHIELD4}
states[S_ANTISHIELD4] = {SPR_ANTI, TR_TRANS30|D, 1, nil, 0, 0, S_ANTISHIELD5}
states[S_ANTISHIELD5] = {SPR_ANTI, TR_TRANS30|E, 1, nil, 0, 0, S_ANTISHIELD6}
states[S_ANTISHIELD6] = {SPR_ANTI, TR_TRANS30|F, 1, nil, 0, 0, S_ANTISHIELD7}
states[S_ANTISHIELD7] = {SPR_ANTI, TR_TRANS30|G, 1, nil, 0, 0, S_ANTISHIELD8}
states[S_ANTISHIELD8] = {SPR_ANTI, TR_TRANS30|H, 1, nil, 0, 0, S_ANTISHIELD9}
states[S_ANTISHIELD9] = {SPR_ANTI, TR_TRANS30|I, 1, nil, 0, 0, S_ANTISHIELD10}
states[S_ANTISHIELD10] = {SPR_ANTI, TR_TRANS30|J, 1, nil, 0, 0, S_ANTISHIELD11}
states[S_ANTISHIELD11] = {SPR_ANTI, TR_TRANS30|K, 1, nil, 0, 0, S_ANTISHIELD12}
states[S_ANTISHIELD12] = {SPR_ANTI, TR_TRANS30|L, 1, nil, 0, 0, S_ANTISHIELD13}
states[S_ANTISHIELD13] = {SPR_ANTI, TR_TRANS30|M, 1, nil, 0, 0, S_ANTISHIELD14}
states[S_ANTISHIELD14] = {SPR_ANTI, TR_TRANS30|N, 1, nil, 0, 0, S_ANTISHIELD15}
states[S_ANTISHIELD15] = {SPR_ANTI, TR_TRANS30|O, 1, nil, 0, 0, S_ANTISHIELD16}
states[S_ANTISHIELD16] = {SPR_ANTI, TR_TRANS30|P, 1, nil, 0, 0, S_ANTISHIELD17}
states[S_ANTISHIELD17] = {SPR_ANTI, TR_TRANS30|Q, 1, nil, 0, 0, S_ANTISHIELD18}
states[S_ANTISHIELD18] = {SPR_ANTI, TR_TRANS30|R, 1, nil, 0, 0, S_ANTISHIELD19}
states[S_ANTISHIELD19] = {SPR_ANTI, TR_TRANS30|S, 1, nil, 0, 0, S_ANTISHIELD20}
states[S_ANTISHIELD20] = {SPR_ANTI, TR_TRANS30|T, 1, nil, 0, 0, S_ANTISHIELD21}
states[S_ANTISHIELD21] = {SPR_ANTI, TR_TRANS30|U, 1, nil, 0, 0, S_ANTISHIELD22}
states[S_ANTISHIELD22] = {SPR_ANTI, TR_TRANS30|V, 1, nil, 0, 0, S_ANTISHIELD23}
states[S_ANTISHIELD23] = {SPR_ANTI, TR_TRANS30|W, 1, nil, 0, 0, S_ANTISHIELD24}
states[S_ANTISHIELD24] = {SPR_ANTI, TR_TRANS30|X, 1, nil, 0, 0, S_ANTISHIELD25}
states[S_ANTISHIELD25] = {SPR_ANTI, TR_TRANS30|Y, 1, nil, 0, 0, S_ANTISHIELD26}
states[S_ANTISHIELD26] = {SPR_ANTI, TR_TRANS30|Z, 1, nil, 0, 0, S_ANTISHIELD27}
states[S_ANTISHIELD27] = {SPR_ANTI, TR_TRANS30|26, 1, nil, 0, 0, S_ANTISHIELD28}
states[S_ANTISHIELD28] = {SPR_ANTI, TR_TRANS30|27, 1, nil, 0, 0, S_ANTISHIELD29}
states[S_ANTISHIELD29] = {SPR_ANTI, TR_TRANS30|28, 1, nil, 0, 0, S_ANTISHIELD30}
states[S_ANTISHIELD30] = {SPR_ANTI, TR_TRANS30|29, 1, nil, 0, 0, S_ANTISHIELD31}
states[S_ANTISHIELD31] = {SPR_ANTI, TR_TRANS30|30, 1, nil, 0, 0, S_ANTISHIELD32}
states[S_ANTISHIELD32] = {SPR_ANTI, TR_TRANS30|31, 1, nil, 0, 0, S_ANTISHIELD1}