function A_TitaniumShield(actor)
	if not actor.target or not actor.target.player
		print("ERROR: A_TitaniumShield: Power up has no target.")
		return
	end

	local p = actor.target.player
	local mo = p.mo

	MP_giveShield(p, SH_TITANIUMSHIELD, 4)
end

local function titthinker(mo)	-- fyi, I like em small, like Kanade's.
	local p = mo.player
	local s = mo.MP_shieldorb
	p.normalspeed = skins[mo.skin].normalspeed - (skins[mo.skin].normalspeed / 12)*s.health
	p.actionspd = skins[mo.skin].actionspd - (skins[mo.skin].actionspd / 12)*s.health

	removealltransflags(s)
	local addflag = s.health >= 4 and TR_TRANS40 or s.health == 3 and TR_TRANS50 or s.health == 2 and TR_TRANS60 or TR_TRANS70
	s.frame = $|addflag
	if not (p.mo.eflags & MFE_UNDERWATER)
		if P_IsObjectOnGround(p.mo) == false
			P_SetObjectMomZ(p.mo, -5400 - ((5400) * (s.health-1)), true)
		else
			if P_IsObjectOnGround(p.mo) == false
				P_SetObjectMomZ(p.mo, -1190 - ((1190) * (s.health-1)), true)
			end
		end
	end
end

local function titspecial(mo)	-- layer removal
	
	S_StartSound(mo, sfx_titanh)
	
	local g = P_SpawnGhostMobj(mo.MP_shieldorb)
	g.destscale = FRACUNIT*8
	g.scalespeed = FRACUNIT/2
	
	mo.MP_shieldorb.health = $-1
	
	if not mo.MP_shieldorb.health
		MP_loseShield(mo.player, true)
	end
	
	mo.player.pflags = $|PF_SHIELDABILITY|PF_THOKKED
end

local function tithit(mo)
end

local tit_data = {
	orbstate = S_TITA_ORB1,
	hudico = "TITANICO",
	sound = sfx_titan,
	func = titthinker,
	hit = tithit,
	change = resetStats,
	special = titspecial,
}
shieldList[SH_TITANIUMSHIELD] = tit_data

addHook("ShouldDamage", function(mo, inflictor, source)
	if mo and mo.valid and mo.player.powers[pw_shield] == SH_TITANIUMSHIELD

		if inflictor and inflictor.valid and (inflictor.flags2 & MF2_RAILRING or inflictor.flags2 & MF2_AUTOMATIC or inflictor.nohit)
			S_StartSound(mo, sfx_rail2)
			local crit = P_SpawnMobj(mo.x, mo.y, mo.z+FRACUNIT*25, MT_THOK)
			crit.state = S_BLOCKED1
			crit.scale = FRACUNIT*3/2
			return false
		end
	end
end, MT_PLAYER)

addHook("MobjDamage", function(mo, inflictor, source)
	if mo and mo.valid and mo.player and mo.player.powers[pw_shield] == SH_TITANIUMSHIELD

		if mo.player and mo.player.powers[pw_super] return end
		S_StartSound(mo, sfx_titanh)

		if (mo.MP_shieldorb and mo.MP_shieldorb.health)
			mo.player.powers[pw_flashing] = TICRATE*3-1
			return true
		else
			resetStats(mo)
		end
	end
end, MT_PLAYER)

MP_buildMonitor(MT_TITANIUMMONITOR, MT_TITANIUMICON, S_TITATV, S_TITAPOP1, SPR_TITA, SPR_TITA, A_TitaniumShield)

states[S_BLOCKED1] = {SPR_TITS, K, 55, nil, 0, 0, S_BLOCKED2}
states[S_BLOCKED2] = {SPR_TITS, K|TR_TRANS20, 4, nil, 0, 0, S_BLOCKED3}
states[S_BLOCKED3] = {SPR_TITS, K|TR_TRANS40, 4, nil, 0, 0, S_BLOCKED4}
states[S_BLOCKED4] = {SPR_TITS, K|TR_TRANS60, 4, nil, 0, 0, S_BLOCKED5}
states[S_BLOCKED5] = {SPR_TITS, K|TR_TRANS80, 4, nil, 0, 0, S_NULL}

states[S_TITA_ORB1] = {SPR_TITS, A|TR_TRANS30, 2, nil, 0, 0, S_TITA_ORB2}
states[S_TITA_ORB2] = {SPR_TITS, B|TR_TRANS30, 2, nil, 0, 0, S_TITA_ORB3}
states[S_TITA_ORB3] = {SPR_TITS, C|TR_TRANS30, 2, nil, 0, 0, S_TITA_ORB4}
states[S_TITA_ORB4] = {SPR_TITS, D|TR_TRANS30, 2, nil, 0, 0, S_TITA_ORB5}
states[S_TITA_ORB5] = {SPR_TITS, E|TR_TRANS30, 2, nil, 0, 0, S_TITA_ORB6}
states[S_TITA_ORB6] = {SPR_TITS, F|TR_TRANS30, 2, nil, 0, 0, S_TITA_ORB7}
states[S_TITA_ORB7] = {SPR_TITS, G|TR_TRANS30, 2, nil, 0, 0, S_TITA_ORB8}
states[S_TITA_ORB8] = {SPR_TITS, H|TR_TRANS30, 2, nil, 0, 0, S_TITA_ORB9}
states[S_TITA_ORB9] = {SPR_TITS, I|TR_TRANS30, 2, nil, 0, 0, S_TITA_ORB10}
states[S_TITA_ORB10] = {SPR_TITS, J|TR_TRANS30, 2, nil, 0, 0, S_TITA_ORB1}